-- Constants
local ADDON_NAME = "GearGrinder"

local L = LibStub("AceLocale-3.0"):GetLocale(ADDON_NAME, false)


--[[
-- globally available constants no need to declare
GARRISON_FOLLOWER_MAX_LEVEL = 100;
GARRISON_FOLLOWER_MAX_UPGRADE_QUALITY = 4;
GARRISON_CURRENCY = 824;
GARRISON_NUM_BUILDING_SIZES = 3;
GARRISON_MAX_BUILDING_LEVEL = 3;
]]

local CURRENCIES = {
	-- General
	HONOR = 392,
	CONQUEST = 390,
	-- MoP
	ELDER = 697,
	LESSER = 738,
	MOGU = 752,
	TIMELESS = 777,
	WARSEAL = 776,
	-- WoD
	APEXIS = 823,   -- Apexis Crystals
	GARRISON = 824, -- Garrisson Resources
	FATE = 994,     -- Seal of Tempered Fate
};
			
local WHITE_BRIGHT_COLOR = "|cffFFFFFF"
local YELLOW_NEON_COLOR = "|cffFFFF00"
local RED_NEON_COLOR = "|cffFF0000"
local ORANGE_NEON_COLOR = "|cffEE6622"
local EPIC_COLOR = "|cffA335EE"
local GREEN_NEON_COLOR = "|cff00FF00"
local GREY_COLOR = "|cff9d9d9d"
local END_COLOR = FONT_COLOR_CODE_CLOSE
local INFO_COLOR = "|cFFFFCC00"

-- useful scripts
--/script for i=1, 1500 do local a,b,_,_,_,_,_,_,d,_,_,c = GetLFGDungeonRewardCapInfo(i); if a then print('GetLFGDungeonRewardCapInfo',i, a, b, c, d) end end
--/script for i=1, 1500 do local a,b,_,_,_,_,_,_,d,_,_,c = GetLFGDungeonInfo(i); if b == 2  then print('GetLFGDungeonInfo',i, a, b, c, d) end end
--/script for i=1, GetNumRFDungeons() do local a,b,_,_,_,_,_,_,_,c = GetRFDungeonInfo(i); print('GetRFDungeonInfo',i, a, b, c) end
--/script for i=801, 1000 do local a,b,c = GetDungeonInfo(i); if a == nil then else print('GetDungeonInfo',i, a, b, c) end end
--/script for i=1, 2000 do local a,b,c = GetDungeonInfo(i); if a == nil then else print('GetDungeonInfo',i, a, b, c) end end
--/script for i=1,1900 do local a,b,c=GetCurrencyInfo(i); if (a~="") then print('GetCurrencyInfo',i,a) end end 

--/script for i=1,1900 do local a,b,c,d,e,f=GetDifficultyInfo(i); if a then print('GetDifficultyInfo',i,a,b,c,d,e,f) end end 

-- local _, _, isHeroic, isChallengeMode, displayHeroic, displayMythic = GetDifficultyInfo(difficulty);
-- interesting API's
-- dungeonID, name, typeID, subtypeID, minLevel, maxLevel, recLevel, minRecLevel, maxRecLevel, expansionLevel, groupID, textureFilename, difficulty, maxPlayers, description, isHoliday, bonusRepAmount = GetLFGRandomDungeonInfo(id)
-- isDisplayable = LFG_IsRandomDungeonDisplayable(dungeonID) 
-- isAvailable, isAvailableToPlayer, hideIfUnmet = IsLFGDungeonJoinable(dungeonID)
-- name, typeID, subtypeID, minLevel, maxLevel, recLevel, minRecLevel, maxRecLevel, expansionLevel, groupID, textureFilename, difficulty, maxPlayers, description, isHoliday, bonusRepAmount = GetLFGDungeonInfo(dungeonID)

local RAID_NAMES = nil;	

-- special dungeonID's
local DUNGEONIDS = {
	H = 462,  	
	D = 463,    
	S = 493,	
	HS = 641,	
	WoD_D = 788, 
	WoD_H = 789,
}; 

local WORLD_BOSSES = {
	-- MoP
	{ID = 1, name = "Sha of Anger",		   title = L.core.BossShaOfAngerShort,	visible = function() return GearGrinder:GetBossSha() end,		avail = function(q) return true end, xpac = 4, justify = "CENTER", quest = 32099},
	{ID = 2, name = "Galleon",			   title = L.core.BossGalleonShort,		visible = function() return GearGrinder:GetBossGalleon() end,	avail = function(q) return true end, xpac = 4, justify = "CENTER", quest = 32098}, 
	{ID = 3, name = "Nalak",			   title = L.core.BossNalakShort,		visible = function() return GearGrinder:GetBossNalak() end,		avail = function(q) return true end, xpac = 4, justify = "CENTER", quest = 32518}, 
	{ID = 4, name = "Oondasta",			   title = L.core.BossOondastaShort,	visible = function() return GearGrinder:GetBossOondasta() end,	avail = function(q) return true end, xpac = 4, justify = "CENTER", quest = 32519}, 
	{ID = 5, name = "The Four Celestials", title = L.core.BossCelestialShort,	visible = function() return GearGrinder:GetBossCelestial() end, avail = function(q) return true end, xpac = 4, justify = "CENTER", quest = 33117}, 
	{ID = 6, name = "Ordos",			   title = L.core.BossOrdosShort,		visible = function() return GearGrinder:GetBossOrdos() end,		avail = function(q) return true end, xpac = 4, justify = "CENTER", quest = 0}, 
	-- WoD
	{ID = 7, name = "Drov",				   title = L.core.BossDrovShort,		visible = function() return GearGrinder:GetBossDrov() end,		avail = function(q) return true end, xpac = 5, justify = "CENTER", quest = 37460}, 
	{ID = 8, name = "Tarina",			   title = L.core.BossTarinaShort,		visible = function() return GearGrinder:GetBossTarina() end,	avail = function(q) return true end, xpac = 5, justify = "CENTER", quest = 37462}, 
	{ID = 9, name = "Rukhmar",			   title = L.core.BossRukhmarShort,		visible = function() return GearGrinder:GetBossRukhmar() end,	avail = function(q) return true end, xpac = 5, justify = "CENTER", quest = 37474}, 
};
	
local RAID_COLUMNS = {
	--LFR/Raids
	{visible = function() return GearGrinder:GetRaidMV() end,   title = L.core.LFR_MV,	 xpac = 4, justify = "CENTER", instanceName = "Mogu'shan Vaults"},
	{visible = function() return GearGrinder:GetRaidHoF() end,  title = L.core.LFR_HoF,	 xpac = 4, justify = "CENTER", instanceName = "Heart of Fear"},
	{visible = function() return GearGrinder:GetRaidToES() end, title = L.core.LFR_ToES, xpac = 4, justify = "CENTER", instanceName = "Terrace of Endless Spring"},
	{visible = function() return GearGrinder:GetRaidToT() end,  title = L.core.LFR_ToT,	 xpac = 4, justify = "CENTER", instanceName = "Throne of Thunder"},
	{visible = function() return GearGrinder:GetRaidSoO() end,  title = L.core.LFR_SoO,	 xpac = 4, justify = "CENTER", instanceName = "Siege of Orgrimmar"},
	{visible = function() return GearGrinder:GetRaidHM() end,   title = L.core.LFR_HM,	 xpac = 5, justify = "CENTER", instanceName = "Highmaul"},
	{visible = function() return GearGrinder:GetRaidBRF() end,  title = L.core.LFR_BRF,	 xpac = 5, justify = "CENTER", instanceName = "Blackrock Foundry"},
};

local GARRISON_COLUMNS = {
	{visible = function() return GearGrinder:GetGarrisonLevel() end, value = function(realm,toon) return GearGrinder:GetTTGarValue(realm,toon,"level") end, title = L.core.Garrison_Level, xpac = 5, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetGarrisonResource() end,	 value = function(realm,toon) return GearGrinder:GetTTCurrencyValue(realm, toon, CURRENCIES.GARRISON) end, title = L.core.PDGarResTextShort,  xpac = 5, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetGarrisonMission() end, value = function(realm,toon) return GearGrinder:GetTTGarMissionValue(realm,toon) end, title = L.core.Garrison_Mission, xpac = 5, justify = "CENTER"},
	{visible = function() return GearGrinder:GetGarrisonShipment() end, value = function(realm,toon) return GearGrinder:GetTTGarShipmentValue(realm,toon) end, title = L.core.Garrison_Shipment, xpac = 5, justify = "CENTER"},
	{visible = function() return GearGrinder:GetGarrisonActivity() end, value = function(realm,toon) return GearGrinder:GetTTGarActivityValue(realm,toon) end, title = L.core.Garrison_Activity, xpac = 5, justify = "CENTER"},
	{visible = function() return GearGrinder:GetGarrisonFollower() end, value = function(realm,toon) return GearGrinder:GetTTGarFollowerValue(realm,toon) end, title = L.core.Garrison_Follower, xpac = 5, justify = "CENTER"},
	{visible = function() return GearGrinder:GetGarrisonBuilding() end, value = function(realm,toon) return GearGrinder:GetTTGarBuildingValue(realm,toon) end, title = L.core.Garrison_Building, xpac = 5, justify = "CENTER"},
};

local CHAR_COLUMNS = {
	{visible = function() return GearGrinder:GetToonLevel() end,	value = function(realm,toon) return GearGrinder:GetTTCharValue(realm,toon,"lvl") end,	title = L.core.PDLvlTextShort,		xpac = 4, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetTooniELevel() end,	value = function(realm,toon) return GearGrinder:GetTTCharValue(realm,toon,"iELvl") end,	title = L.core.PDiELvlTextShort,	xpac = 4, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetTooniLevel() end,	value = function(realm,toon) return GearGrinder:GetTTCharValue(realm,toon,"iLvl") end,	title = L.core.PDiLvlTextShort,		xpac = 4, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetToonCPCap() end,	value = function(realm,toon) return GearGrinder:GetTTCurrencyEarnValue(realm,toon, CURRENCIES.CONQUEST) end, title = L.core.PDCPCapTextShort,	xpac = 4, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetToonCP() end,		value = function(realm,toon) return GearGrinder:GetTTCurrencyValue(realm, toon, CURRENCIES.CONQUEST) end, title = L.core.PDCPTextShort,		  xpac = 4, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetToonHP() end,		value = function(realm,toon) return GearGrinder:GetTTCurrencyValue(realm, toon, CURRENCIES.HONOR) end,    title = L.core.PDHPTextShort,		  xpac = 4, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetToonTimeless() end, value = function(realm,toon) return GearGrinder:GetTTCurrencyValue(realm, toon, CURRENCIES.TIMELESS) end, title = L.core.PDTimelessTextShort, xpac = 4, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetToonApexis() end,	value = function(realm,toon) return GearGrinder:GetTTCurrencyValue(realm, toon, CURRENCIES.APEXIS) end,   title = L.core.PDApexisTextShort,	  xpac = 5, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetToonGarRes() end,	value = function(realm,toon) return GearGrinder:GetTTCurrencyValue(realm, toon, CURRENCIES.GARRISON) end, title = L.core.PDGarResTextShort,	  xpac = 5, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetToonCharms() end,	value = function(realm,toon) return GearGrinder:GetTTCharCharmValue(realm,toon) end,	title = L.core.PDCharmTextShort,	xpac = 4, justify = "RIGHT"},
	{visible = function() return GearGrinder:GetToonActivity() end, value = function(realm,toon) return GearGrinder:GetTTCharActivityValue(realm,toon) end, title = L.core.PDActivityTextShort, xpac = 4, justify = "CENTER"},
	{visible = function() return GearGrinder:GetToonProfCD() end,	value = function(realm,toon) return GearGrinder:GetTTCharProfCDValue(realm,toon) end,	title = L.core.PDProfCDTextShort,	xpac = 4, justify = "CENTER"},
	--{visible = function() return GearGrinder:GetToonFarm() end,		value = function(realm,toon) return GearGrinder:GetTTCharFarmValue(realm,toon) end,		title = "Farm",						xpac = 4, justify = "CENTER"},
};

--local LFR_STARTER_DUNGEON = 527;
				
local QUESTS = {
	-- MoP
	farm4    = 30256, -- Learn and Grow IV: Harvesting
	farm8    = 30516, -- Growing the Farm I: A Little Problem
	farm12   = 30524, -- Growing the Farm II: Knock on Wood
	farm16   = 30529, -- Growing the Farm III: The Mossy Boulder
	-- WoD
	qFateA1  = 36055, -- 1/3 Apexis Crystals
	qFateA2  = 37452, -- 2/3 Apexis Crystals
	qFateA3  = 37453, -- 3/3 Apexis Crystals
	qFateG1  = 36054, -- 1/3 Gold
	qFateG2  = 37454, -- 2/3 Gold
	qFateG3  = 37455, -- 3/3 Gold
	qFateH1  = 36057, -- 1/3 Honor
	qFateH2  = 37458, -- 2/3 Honor
	qFateH3  = 37459, -- 3/3 Honor
	qFateGR1 = 36056, -- 1/3 Garrison Resources
	qFateGR2 = 37456, -- 2/3 Garrison Resources
	qFateGR3 = 37457, -- 3/3 Garrison Resources
	-- Ring of Blood
	qRoB1		= 36672, -- The Ring of Blood: Venoxis!
	qRoB2		= 36670, -- The Ring of Blood: Skull Chewer!
	qRoB3		= 36705, -- The Ring of Blood: Mogor!
	qRoB4		= 36671, -- The Ring of Blood: Fracktus!
	qRoB5		= 36673, -- The Ring of Blood: Dreshax!
	-- Daily Challenge Heroic
	qC1			= 37265, -- A Worthy Challenge: Yalnu
	qC2			= 37278, -- A Worthy Challenge: Yalnu
	qC3			= 37260, -- A Worthy Challenge: Gug'rokk
	qC4			= 37272, -- A Worthy Challenge: Gug'rokk
	qC5			= 37264, -- A Worthy Challenge: High Sage Viryx
	qC6			= 37277, -- A Worthy Challenge: High Sage Viryx
	qC7			= 37263, -- A Worthy Challenge: Ner'zhul
	qC8			= 37275, -- A Worthy Challenge: Ner'zhul
	qC9			= 37262, -- A Worthy Challenge: Skullok, Son of Gruul
	qC10		= 37274, -- A Worthy Challenge: Skullok, Son of Gruul
	qC11		= 37261, -- A Worthy Challenge: Skylord Tovra
	qC12		= 37273, -- A Worthy Challenge: Skylord Tovra
	qC13		= 37259, -- A Worthy Challenge: Teron'gor
	qC14		= 37271, -- A Worthy Challenge: Teron'gor
	qC15		= 37266, -- A Worthy Challenge: Warlord Zaela
	qC16		= 37279, -- A Worthy Challenge: Warlord Zaela
	-- Garrison Activities
	--- Daily Heroic
	gH1			= 37228, -- A Fruitful Proposition
	gH2			= 37237, -- A Hero's Quest is Never Complete
	gH3			= 37235, -- A Plea to the Sky
	gH4			= 37243, -- An Axe to Grind
	gH5			= 37233, -- Vessel of Virtue
	gH6			= 37231, -- The Search Continues
	gH7			= 37240, -- The Leaf-Reader
	gH8			= 37234, -- The Dark Within
	gH9			= 37232, -- Soulcarver Voss
	gH10		= 37238, -- Secrets of Soulbinding
	gH11		= 37236, -- Like Father, Like Son
	gH12		= 37229, -- Like A Dwarf In A Mine
	gH13		= 37241, -- Lessons of the Past
	gH14		= 37242, -- Learning Is Painful
	gH15		= 37239, -- Fate of the Fallen
	gH16		= 37230, -- Bloody Expensive
	-- Assault Daily
	gA1			= 36674, -- Assault on the Iron Siegeworks
	gA2			= 36696, -- Assault on the Iron Siegeworks
	gA3			= 36677, -- Assault on the Broken Precipice
	gA4			= 36694, -- Assault on the Broken Precipice
	gA5			= 36678, -- Assault on Mok'gol Watchpost
	gA6			= 36693, -- Assault on Mok'gol Watchpost
	gA7			= 36695, -- Assault on the Everbloom Wilds
	gA8			= 36676, -- Assault on the Everbloom Wilds
	gA9			= 36697, -- Assault on Magnarok
	gA10		= 36675, -- Assault on Magnarok
	gA11		= 37523, -- Assault on the Gorian Proving Grounds
	gA12		= 37524, -- Assault on the Gorian Proving Grounds
	gA13		= 36649, -- Assault on Shattrath Harbor
	gA14		= 36667, -- Assault on Shattrath Harbor
	gA15		= 36680, -- Assault on Socrethar's Rise
	gA16		= 36691, -- Assault on Socrethar's Rise
	gA17		= 36682, -- Assault on Pillars of Fate
	gA18		= 36689, -- Assault on Pillars of Fate
	gA19		= 36669, -- Assault on Stonefury Cliffs
	gA20		= 36648, -- Assault on Stonefury Cliffs
	gA21		= 36688, -- Assault on Skettis
	gA22		= 36683, -- Assault on Skettis
	gA23		= 36690, -- Assault on Lost Veil Anzu
	gA24		= 36681, -- Assault on Lost Veil Anzu
	gA25		= 36692, -- Assault on Darktide Roost
	gA26		= 36679, -- Assault on Darktide Roost
	-- Group Assault Daily
	gGA1		= 36701, -- Assault on the Pit
	gGA2		= 36686, -- Assault on the Pit
	gGA3		= 36699, -- Assault on the Heart of Shattrath
	gGA4		= 36685, -- Assault on the Heart of Shattrath
	-- Garrison Jewelcrafting Daily
	gJC1		= 37320, -- Jewelcrafting Special Order: A Fine Choker
	gJC2		= 37324, -- Out of Stock: Blackrock Ore
	gJC3		= 37319, -- Jewelcrafting Special Order: Wedding Bands
	gJC4		= 37323, -- Jewelcrafting Special Order: Blue the Shade of Sky 
	gJC5		= 37321, -- Jewelcrafting Special Order: A Yellow Brighter Than Gold
	-- Garrison Alchemy Daily
	gAL1		= 37270, -- Alchemy Experiment
};
			
local TRADE_SKILLS = {
	["Transmute: Living Steel"]       = { visible = function() return GearGrinder:GetProfAlc() end,     xpac = 4, title = L.core.ProfAlcText, },
	["Lightning Steel Ingot"]         = { visible = function() return GearGrinder:GetProfBS() end,      xpac = 4, title = L.core.ProfBSText, },
	["Balanced Trillium Ingot"]       = { visible = function() return GearGrinder:GetProfBS2() end,     xpac = 4, title = L.core.ProfBS2Text, },
	["Imperial Silk"]                 = { visible = function() return GearGrinder:GetProfTailor() end,  xpac = 4, title = L.core.ProfTailorText, },
	["Celestial Cloth"]               = { visible = function() return GearGrinder:GetProfTailor2() end, xpac = 4, title = L.core.ProfTailor2Text, },
	["Sha Crystal"]                   = { visible = function() return GearGrinder:GetProfEnch() end,    xpac = 4, title = L.core.ProfEnchText, },
	["Scroll of Wisdom"]              = { visible = function() return GearGrinder:GetProfScribe() end,  xpac = 4, title = L.core.ProfScribeText, },
	["Wild Jade"]                     = { visible = function() return GearGrinder:GetProfJCGem() end,   xpac = 4, title = L.core.ProfJCGemText, },  -- just needed to pick one of them
	["Serpent's Heart"]               = { visible = function() return GearGrinder:GetProfJCHeart() end, xpac = 4, title = L.core.ProfJCHeartText, },
	["Magnificence of Leather"]       = { visible = function() return GearGrinder:GetProfLW() end,      xpac = 4, title = L.core.ProfLWText, },
	["Hardened Magnificent Hide"]     = { visible = function() return GearGrinder:GetProfLW2() end,     xpac = 4, title = L.core.ProfLW2Text, },
	["Jard's Peculiar Energy Source"] = { visible = function() return GearGrinder:GetProfEng() end,     xpac = 4, title = L.core.ProfEngText, },
	-- WoD Professions
	["Alchemical Catalyst"]               = { visible = function() return GearGrinder:GetProfWoDAlc1() end,    xpac = 5, title = L.core.ProfWoDAlc1Text, },
	["Secrets of Draenor Alchemy"]        = { visible = function() return GearGrinder:GetProfWoDAlc2() end,    xpac = 5, title = L.core.ProfWoDAlc2Text, },
	["Truesteel Ingot"]                   = { visible = function() return GearGrinder:GetProfWoDBS1() end,     xpac = 5, title = L.core.ProfWoDBS1Text, },
	["Secrets of Draenor Blacksmithing"]  = { visible = function() return GearGrinder:GetProfWoDBS2() end,     xpac = 5, title = L.core.ProfWoDBS2Text, },
	["Temporal Crystal"]                  = { visible = function() return GearGrinder:GetProfWoDEnc1() end,    xpac = 5, title = L.core.ProfWoDEnc1Text, },
	["Secrets of Draenor Enchanting"]     = { visible = function() return GearGrinder:GetProfWoDEnc2() end,    xpac = 5, title = L.core.ProfWoDEnc2Text, },
	["Gearspring Parts"]                  = { visible = function() return GearGrinder:GetProfWoDEng1() end,    xpac = 5, title = L.core.ProfWoDEng1Text, },
	["Secrets of Draenor Engineering"]    = { visible = function() return GearGrinder:GetProfWoDEng2() end,    xpac = 5, title = L.core.ProfWoDEng2Text, },
	["War Paints"]                        = { visible = function() return GearGrinder:GetProfWoDScribe1() end, xpac = 5, title = L.core.ProfWoDScribe1Text, },
	["Secrets of Draenor Inscription"]    = { visible = function() return GearGrinder:GetProfWoDScribe2() end, xpac = 5, title = L.core.ProfWoDScribe2Text, },
	["Taladite Crystal"]                  = { visible = function() return GearGrinder:GetProfWoDJC1() end,     xpac = 5, title = L.core.ProfWoDJC1Text, },
	["Secrets of Draenor Jewelcrafting"]  = { visible = function() return GearGrinder:GetProfWoDJC2() end,     xpac = 5, title = L.core.ProfWoDJC2Text, },
	["Burnished Leather"]                 = { visible = function() return GearGrinder:GetProfWoDLW1() end,     xpac = 5, title = L.core.ProfWoDLW1Text, },
	["Secrets of Draenor Leatherworking"] = { visible = function() return GearGrinder:GetProfWoDLW2() end,     xpac = 5, title = L.core.ProfWoDLW2Text, },
	["Hexweave Cloth"]                    = { visible = function() return GearGrinder:GetProfWoDTailor1() end, xpac = 5, title = L.core.ProfWoDTailor1Text, },
	["Secrets of Draenor Tailoring"]      = { visible = function() return GearGrinder:GetProfWoDTailor2() end, xpac = 5, title = L.core.ProfWoDTailor2Text, },
};

local GARRISON_BUILDING = {
	[61]  = "Mine",
	[62]  = "Mine",
	[63]  = "Mine",
	[29]  = "Herb",
	[136] = "Herb",
	[137] = "Herb",
};

local GARRISON_SPELL_ACTION = {
	[170599] = "Mine", -- Non-Miner
	[158754] = "Mine", -- Miner
	[170691] = "Herb", -- Non-Herber
	[158745] = "Herb", -- Herber
};

local FARM_SPELL_ACTION = {
	[111102] = "Sow", -- Plant Green Cabbage
	[123361] = "Sow", -- Plant Juicycrunch Carrot
	[123388] = "Sow", -- Plant Scallions
	[123485] = "Sow", -- Plant Mogu Pumpkin
	[123535] = "Sow", -- Plant Red Blossom Leek
	[123565] = "Sow", -- Plant Pink Turnip
	[123568] = "Sow", -- Plant White Turnip
	[123771] = "Sow", -- Plant Golden Seed
	[123772] = "Sow", -- Plant Seed of Harmony
	[123773] = "Sow", -- Plant Snakeroot Seed
	[123774] = "Sow", -- Plant Enigma Seed
	[123775] = "Sow", -- Plant Magebulb Seed
	[123776] = "Sow", -- Plant Soybean Seed
	[123777] = "Sow", -- Plant Ominous Seed
	[123892] = "Sow", -- Plant Autumn Blossom Sapling
	[123893] = "Sow", -- Plant Spring Blossom Seed
	[123894] = "Sow", -- Plant Winter Blossom Sapling
	[123895] = "Sow", -- Plant Kyparite Seed
	[129623] = "Sow", -- Plant Windshear Cactus Seed
	[129628] = "Sow", -- Plant Raptorleaf Seed
	[129863] = "Sow", -- Plant Songbell Seed
	[129974] = "Sow", -- Plant Witchberries
	[129976] = "Sow", -- Plant Jade Squash
	[129978] = "Sow", -- Plant Striped Melon
	[130170] = "Sow", -- Plant Spring Blossom Sapling
	[133036] = "Sow", -- Plant Unstable Portal Shard
	[116356] = "Sow4", -- Throw Green Cabbage Seeds
	[123362] = "Sow4", -- Throw Juicycrunch Carrot Seeds
	[123389] = "Sow4", -- Throw Scallion Seeds
	[123486] = "Sow4", -- Throw Mogu Pumpkin Seeds
	[123537] = "Sow4", -- Throw Red Blossom Leek Seeds
	[123566] = "Sow4", -- Throw Pink Turnip Seeds
	[123567] = "Sow4", -- Throw White Turnip Seeds
	[131093] = "Sow4", -- Throw Witchberry Seeds
	[131094] = "Sow4", -- Throw Jade Squash Seeds
	[131095] = "Sow4", -- Throw Striped Melon Seeds
	[139975] = "Sow4", -- Throw Songbell Seeds
	[139977] = "Sow4", -- Throw Snakeroot Seeds
	[139978] = "Sow4", -- Throw Enigma Seeds
	[139981] = "Sow4", -- Throw Magebulb Seeds
	[139983] = "Sow4", -- Throw Windshear Cactus Seeds
	[139986] = "Sow4", -- Throw Raptorleaf Seeds				
	[111123] = "Harvest", -- Harvest Green Cabbage
	[115063] = "Harvest", -- Harvest EZ-Gro Green Cabbage
	[123353] = "Harvest", -- Harvest Juicycrunch Carrot
	[123355] = "Harvest", -- Harvest Plump Green Cabbage
	[123356] = "Harvest", -- Harvest Plump Juicycrunch Carrot
	[123375] = "Harvest", -- Harvest Scallions
	[123380] = "Harvest", -- Harvest Plump Scallions
	[123445] = "Harvest", -- Harvest Mogu Pumpkin
	[123451] = "Harvest", -- Harvest Plump Mogu Pumpkin
	[123516] = "Harvest", -- Harvest Winter Blossom Tree
	[123522] = "Harvest", -- Harvest Plump Red Blossom Leek
	[123524] = "Harvest", -- Harvest Red Blossom Leek
	[123548] = "Harvest", -- Harvest Pink Turnip
	[123549] = "Harvest", -- Harvest Plump Pink Turnip
	[123570] = "Harvest", -- Harvest White Turnip
	[123571] = "Harvest", -- Harvest Plump White Turnip
	[129673] = "Harvest", -- Harvest Golden Lotus
	[129674] = "Harvest", -- Harvest Fool\'s Cap
	[129675] = "Harvest", -- Harvest Snow Lily
	[129676] = "Harvest", -- Harvest Silkweed
	[129687] = "Harvest", -- Harvest Green Tea Leaf
	[129705] = "Harvest", -- Harvest Rain Poppy
	[129757] = "Harvest", -- Harvest Snakeroot
	[129796] = "Harvest", -- Harvest Magebulb
	[129814] = "Harvest", -- Harvest Windshear Cactus
	[129843] = "Harvest", -- Harvest Raptorleaf
	[129887] = "Harvest", -- Harvest Songbell
	[129983] = "Harvest", -- Harvest Witchberries
	[129984] = "Harvest", -- Harvest Plump Witchberries
	[130025] = "Harvest", -- Harvest Jade Squash
	[130026] = "Harvest", -- Harvest Plump Jade Squash
	[130042] = "Harvest", -- Harvest Striped Melon
	[130043] = "Harvest", -- Harvest Plump Striped Melon
	[130109] = "Harvest", -- Harvest Terrible Turnip
	[130140] = "Harvest", -- Harvest Autumn Blossom Tree
	[130168] = "Harvest", -- Harvest Spring Blossom Tree
	[133106] = "Harvest", -- Harvest Portal Shard
};

local CLASS_COLOR = {
	DEATHKNIGHT = "|cFFC41F3B",
	DRUID = "|cFFFF7D0A",
	HUNTER = "|cFFABD473",
	MAGE = "|cFF69CCF0",
	MONK = "|cFF00FF96",
	PALADIN = "|cFFF58CBA",
	PRIEST = "|cFFFFFFFF",
	ROGUE = "|cFFFFF569",
	SHAMAN = "|cFF0070DE",
	WARLOCK = "|cFF9482C9",
	WARRIOR = "|cFFC79C6E"
}

-- Start Gear Grinder
GearGrinder = LibStub("AceAddon-3.0"):NewAddon(ADDON_NAME, "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0")
GearGrinder.version = GetAddOnMetadata(ADDON_NAME, "Version")
GearGrinder.category = GetAddOnMetadata(ADDON_NAME, "X-Category")
GearGrinder.versionMajor = 2;    -- Used for DB versioning

-- Load Libs
GearGrinder.LSM = LibStub:GetLibrary("LibSharedMedia-3.0")
GearGrinder.aceConfig = LibStub:GetLibrary("AceConfig-3.0")
GearGrinder.aceConfigDialog = LibStub:GetLibrary("AceConfigDialog-3.0")
GearGrinder.QTip = LibStub("LibQTip-1.0")
GearGrinder.LDB = LibStub("LibDataBroker-1.1")
GearGrinder.LDBIcon = LibStub("LibDBIcon-1.0")
GearGrinder.CBH = LibStub("CallbackHandler-1.0"):New(GearGrinder)

GearGrinder.currentPlayer = UnitName('player')	-- name of the logged-in character.
GearGrinder.currentRealm = GetRealmName()		-- current Realm we're on.
_, GearGrinder.currentClass = UnitClass("player") -- class of the current character.
GearGrinder.menu = false       -- Menu frame
GearGrinder.menuItems = {       -- Table for the dropdown menu
    top = {},
    middle = {},
    bottom = {},
}
GearGrinder.periodMaxCP = -1
GearGrinder.maxCP = -1
GearGrinder.maxHP = -1
GearGrinder.timezone = time({year=1970, month=1, day=2, hour=0})-86400

GearGrinder.LDBObj = {
    type = "data source",
		icon = "Interface\\Icons\\Ability_AnimusOrbs",
		-- Ability_Butcher_Cleave

		iconCoords = { 0.075, 0.925, 0.075, 0.925 },
    label = L.core.buttonLabel,
    text = 'n/a',
    category = GearGrinder.category,
    version = GearGrinder.version,
		OnEnter = function(frame)
  		-- if disabled during combat then don't show anything
      if InCombatLockdown() ~= nil and InCombatLockdown() == 1 and not GearGrinder:GetShowCombat() then return end
      GearGrinder:SetTooltipText(frame)
		end,
		OnLeave = function(frame) 
		end,
		OnClick = function(frame, button)
			if button == "RightButton" then
				GearGrinder:ShowOptions()
			end

      if button == "LeftButton" then
        --do nothing
      end
		end
	}
	
-- OnLoad
function GearGrinder:OnInitialize()

    -- Make sure everything is ok with the db
    if not GG_Storage or type(GG_Storage) ~= 'table' then GG_Storage = {} end
	
	if not self:Validate() then return end
	
    -- Tell the player we are being loaded
	self:Print(format(L.core.load, self.version))
        
    -- Load settings
    self.db = LibStub("AceDB-3.0"):New("GG_Settings", GG_Defaults, true)
	self:UpdateSettings()

	-- Set back to a launcher if text is off
	if not self:GetLDB() then
		self.LDBObj.type = 'launcher'
		self.LDBObj.text = ''
	end
        -- Start LDB
	self.LDBObj = self.LDB:NewDataObject(ADDON_NAME, self.LDBObj)

	-- Start the minimap icon
	self.LDBIcon:Register(ADDON_NAME, self.LDBObj, self.db.global.minimap)
    
    -- Register Options
	--GG_Options.args.purge.desc = format(L.core.options.purgeDesc, self:GetPurge() / 24)
	self.aceConfig:RegisterOptionsTable(L.core.name, GG_Options, {"GearGrinder", "GearGrinder"})
	--self.aceConfigDialog:AddToBlizOptions(L.core.name)
	
	self.optionsFrames = {}
	self.optionsFrames.GearGrinder  = self.aceConfigDialog:AddToBlizOptions(L.core.name, L.core.name, nil, "general")
	self.optionsFrames.ttToon	    = self.aceConfigDialog:AddToBlizOptions(L.core.name, "Character Details", L.core.name, "ttToons")
	self.optionsFrames.ttCharms	    = self.aceConfigDialog:AddToBlizOptions(L.core.name, "Bonus Roll Tokens", L.core.name, "ttCharms")
	self.optionsFrames.ttBoss	    = self.aceConfigDialog:AddToBlizOptions(L.core.name, "World Bosses", L.core.name, "ttBoss")
	self.optionsFrames.ttRaids	    = self.aceConfigDialog:AddToBlizOptions(L.core.name, "Raids", L.core.name, "ttRaids")
	self.optionsFrames.ttGarrison   = self.aceConfigDialog:AddToBlizOptions(L.core.name, "Garrison", L.core.name, "ttGarrison")
	self.optionsFrames.ttActivities	= self.aceConfigDialog:AddToBlizOptions(L.core.name, "Activities", L.core.name, "ttActivities")
	self.optionsFrames.ttProfs	    = self.aceConfigDialog:AddToBlizOptions(L.core.name, "Professions", L.core.name, "ttProfs")
	self.optionsFrames.ldbOpt	    = self.aceConfigDialog:AddToBlizOptions(L.core.name, "LDB", L.core.name, "ldbOpt")
	self.optionsFrames.Background	= self.aceConfigDialog:AddToBlizOptions(L.core.name, "Background", L.core.name, "Background")
	
	
    -- Events
	self:RegisterEvent("MERCHANT_CLOSED",         function() GearGrinder:SaveData("MERCHANT_CLOSED"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("PLAYER_ENTERING_WORLD",   function() 
		RequestRaidInfo();
		GearGrinder:SaveData("PLAYER_ENTERING_WORLD"); 
		GearGrinder:UpdateLDB(true) 
	end)
	self:RegisterEvent("UPDATE_INSTANCE_INFO",    function() GearGrinder:SaveData("UPDATE_INSTANCE_INFO"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("PVP_REWARDS_UPDATE",      function() GearGrinder:SaveData("UPDATE_INSTANCE_INFO"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("LFG_COMPLETION_REWARD",   function() 
		--PVEFrame_ToggleFrame("GroupFinderFrame", nil); 
		--PVEFrame_ToggleFrame("GroupFinderFrame", nil); 
		RequestRaidInfo();
		GearGrinder:SaveData("LFG_COMPLETION_REWARD"); 
		GearGrinder:UpdateLDB(true) 
	end)

	self:RegisterEvent("PLAYER_AVG_ITEM_LEVEL_UPDATE", function() 
		RequestRaidInfo();
		GearGrinder:SaveData("PLAYER_AVG_ITEM_LEVEL_UPDATE"); 
		GearGrinder:UpdateLDB(true) 
	end)
	self:RegisterEvent("HEIRLOOMS_UPDATED", function() GearGrinder:SaveData("HEIRLOOMS_UPDATED"); GearGrinder:UpdateLDB(true) end)
	--self:RegisterEvent("LOOT_ITEM_ROLL_WON", function() GearGrinder:SaveData("LOOT_ITEM_ROLL_WON"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("SCENARIO_COMPLETED", function() GearGrinder:SaveData("SCENARIO_COMPLETED"); GearGrinder:UpdateLDB(true) end)
	
	self:RegisterEvent("PLAYER_REGEN_ENABLED",    function() 
		RequestRaidInfo();
		GearGrinder:SaveData("PLAYER_REGEN_ENABLED"); 
		GearGrinder.InCombat = false; 
		GearGrinder:UpdateLDB(true) 
	end)
	self:RegisterEvent("PLAYER_REGEN_DISABLED",   function() GearGrinder.InCombat = true end)
    self:RegisterEvent("CURRENCY_DISPLAY_UPDATE", function() GearGrinder:SaveData("CURRENCY_DISPLAY_UPDATE"); GearGrinder:UpdateLDB(true) end)
    self:RegisterEvent("LOOT_CLOSED",             function() 
		RequestRaidInfo();
		C_Garrison.RequestLandingPageShipmentInfo();
		GearGrinder:SaveData("LOOT_CLOSED"); 
		GearGrinder:UpdateLDB(true) 
	end)


	self:RegisterEvent("BAG_UPDATE",              function() GearGrinder:SaveData("BAG_UPDATE"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("QUEST_FINISHED",          function() GearGrinder:SaveData("QUEST_FINISHED"); GearGrinder:SaveCurrencyData("QUEST_FINISHED"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("TRADE_SKILL_SHOW",        function() GearGrinder:SaveTradeData("TRADE_SKILL_SHOW"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("TRADE_SKILL_UPDATE",      function() GearGrinder:SaveTradeData("TRADE_SKILL_UPDATE"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("COMBAT_LOG_EVENT",        function(self, eventTime, ...) GearGrinder:CheckCombat(self, eventTime, ...) end)
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	
	--------
	-- Garrison Update Events
	self:RegisterEvent("GARRISON_BUILDING_LIST_UPDATE",      function() GearGrinder:SaveGarrisonData("GARRISON_BUILDING_LIST_UPDATE"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_BUILDING_UPDATE",      function() GearGrinder:SaveGarrisonData("GARRISON_BUILDING_UPDATE"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_FOLLOWER_LIST_UPDATE",      function() GearGrinder:SaveGarrisonData("GARRISON_FOLLOWER_LIST_UPDATE"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_MISSION_LIST_UPDATE",      function() GearGrinder:SaveGarrisonData("GARRISON_MISSION_LIST_UPDATE"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_UPDATE",      function() GearGrinder:SaveGarrisonData("GARRISON_UPDATE"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("SHIPMENT_CRAFTER_REAGENT_UPDATE",      function() GearGrinder:SaveGarrisonData("SHIPMENT_CRAFTER_REAGENT_UPDATE"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("SHIPMENT_UPDATE",      function() GearGrinder:SaveGarrisonData("SHIPMENT_UPDATE"); GearGrinder:UpdateLDB(true) end)

	self:RegisterEvent("GARRISON_BUILDING_PLACED",      function() GearGrinder:SaveGarrisonData("GARRISON_BUILDING_PLACED"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_BUILDING_ACTIVATED",      function() GearGrinder:SaveGarrisonData("GARRISON_BUILDING_ACTIVATED"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_UPGRADEABLE_RESULT",      function() GearGrinder:SaveGarrisonData("GARRISON_UPGRADEABLE_RESULT"); GearGrinder:UpdateLDB(true) end)
	
	self:RegisterEvent("SHIPMENT_CRAFTER_CLOSED",      function() C_Garrison.RequestLandingPageShipmentInfo(); end)
	self:RegisterEvent("SHIPMENT_CRAFTER_INFO",      function() C_Garrison.RequestLandingPageShipmentInfo(); end)
	self:RegisterEvent("SHIPMENT_CRAFTER_OPENED",      function() C_Garrison.RequestLandingPageShipmentInfo(); end)
	self:RegisterEvent("GARRISON_LANDINGPAGE_SHIPMENTS",      function() GearGrinder:SaveGarrisonData("GARRISON_LANDINGPAGE_SHIPMENTS"); GearGrinder:UpdateLDB(true) end)

	self:RegisterEvent("GARRISON_FOLLOWER_REMOVED",      function() GearGrinder:SaveGarrisonData("GARRISON_FOLLOWER_REMOVED"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_FOLLOWER_XP_CHANGED",      function() GearGrinder:SaveGarrisonData("GARRISON_FOLLOWER_XP_CHANGED"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_RECRUITMENT_READY",      function() GearGrinder:SaveGarrisonData("GARRISON_RECRUITMENT_READY"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_MISSION_STARTED",      function() GearGrinder:SaveGarrisonData("GARRISON_MISSION_STARTED"); GearGrinder:UpdateLDB(true) end)
	self:RegisterEvent("GARRISON_MISSION_FINISHED",      function() GearGrinder:SaveGarrisonData("GARRISON_MISSION_FINISHED"); GearGrinder:UpdateLDB(true) end)
	
	--self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", function(self, eventTime, ...) GearGrinder:CheckCombat(self, eventTime, ...) end)
	
    -- Build the menu
    --self:MenuInitialize();
    
    -- Get working on a score for the player
    --self:UpdateLDB(); -- This may cause excesive loading time...
    --GearGrinderHelpFrame:Hide()


end

local bgFrame = {insets = {}}

function GearGrinder:UpdateBackdrop(tt)
	bgFrame.bgFile = self.LSM:Fetch("background", self.db.global.Background.Texture)
	bgFrame.edgeFile = self.LSM:Fetch("border", self.db.global.Background.BorderTexture)
	bgFrame.tile = self.db.global.Background.Tile
	bgFrame.tileSize = self.db.global.Background.TileSize
	bgFrame.edgeSize = self.db.global.Background.EdgeSize
	local inset = floor(self.db.global.Background.EdgeSize / 4)
	bgFrame.insets.left = inset
	bgFrame.insets.right = inset
	bgFrame.insets.top = inset
	bgFrame.insets.bottom = inset
	tt:SetBackdrop(bgFrame)

	local c = self.db.global.Background.Color
	tt:SetBackdropColor(c.r, c.g, c.b, c.a)

	c = self.db.global.Background.BorderColor
	tt:SetBackdropBorderColor(c.r, c.g, c.b, c.a)
	--tt:SetBackdropBorderColor(100, 100, 100, 100)
end

function GearGrinder:SetTooltipText(f)
    -- Tooltip title
	if not self:Validate() then return end
	
	RequestRaidInfo();
	UpdateMicroButtons();
	self:SaveData("TOOLTIP");

	local val = format(L.core.menuText, format(L.core.versionText, self.version));
	local num_columns, line = self:GetTooltipColumns(), 0;
	
	if num_columns == 1 then num_columns = 2 end -- number of columns must be >= 2
	
	if self.LDBtip then self.QTip:Release(self.LDBtip) end
	self.LDBtip = self.QTip:Acquire(ADDON_NAME .. "TT", num_columns)
	tt = self.LDBtip
	tt.anchorframe = f
	tt:EnableMouse()
	tt:SetScale(self:GetTTScale())
	tt:SetAutoHideDelay(0.1, f)
	tt:SmartAnchorTo(f)
	--tt:SetAutoHideDelay(0.1, f)	
	tt:Clear()
	
	GearGrinder:UpdateBackdrop(tt)
	
	line = tt:AddHeader(".")
	tt:SetCell(line, 1, val, "CENTER", num_columns)
	--tt:SetText(val, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);

	-- calculate the time remaining.
	local dtNext = self:GetNextWeeklyReset();
	local dtPrev = dtNext - (7 * 24 * 60 * 60);
 	local timeRemaining = dtNext - time();

	line = tt:AddSeparator()
	
	line = tt:AddLine("" .. L.core.cooldownInfoText, ".")
	val = WHITE_BRIGHT_COLOR .. SecondsToTime(timeRemaining) .. END_COLOR --self:GetRemainingTimeText(timeRemaining)
	tt:SetCell(line, 2, val, "LEFT", num_columns-1)
	
	if self:GetDebug() then
		line = tt:AddLine("Now: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", time()) .. "   " .. time() .. END_COLOR)
		--tt:AddLine("  Last Reset: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtPrev) .. "   " .. dtPrev .. END_COLOR);
		--tt:AddLine("  Date: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtDate) .. "   " .. dtDate .. END_COLOR);
		--tt:AddLine("  Time: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", sec) .. "   " .. sec .. END_COLOR);
		--tt:AddLine("  Resets: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtNext) .. "   " .. dtNext .. END_COLOR);
	end
	line = tt:AddLine("" .. L.core.cooldownInfoLastText, ".")
	val = WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtPrev) .. END_COLOR
	tt:SetCell(line, 2, val, "LEFT", num_columns-1)
	
	line = tt:AddLine("" .. L.core.cooldownInfoNextText, ".");
	val = WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtNext) .. END_COLOR
	tt:SetCell(line, 2, val, "LEFT", num_columns-1)
	
	--tt:AddLine("  Date: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtDate) .. "   " .. dtDate .. END_COLOR);
	line = tt:AddLine(" ")
	--tt:AddSeparator();
	
	if self:GetRaid() then
		self:LoadAltRaid(tt)
		tt:AddLine(" ")
	end
	
	if self:GetGarrison() then
		self:LoadAltGarrison(tt)
		tt:AddLine(" ")
	end

	self:LoadAlt(tt)

	-- add the "Toggle the display of <toon>" line at the end
	if self:GetFiltering() then
		line = tt:AddLine(" ")
		line = tt:AddLine(".", ".")
		if self:GetToonShowRealm() then
			tt:SetCell(line, 1, INFO_COLOR .. "Click to toggle the display of " .. CLASS_COLOR[self.currentClass] .. self.currentPlayer .. '-' .. self.currentRealm .. END_COLOR, "CENTER", num_columns)
		else
			tt:SetCell(line, 1, INFO_COLOR .. "Click to toggle the display of " .. CLASS_COLOR[self.currentClass] .. self.currentPlayer .. END_COLOR, "CENTER", num_columns)
		end
		tt:SetCellScript(line, 1, "OnMouseUp", function(frame) GearGrinder:ToggleToonFilter(); GearGrinder.LDBtip:Hide() end)
	end
	
	tt:Show()	

end

function GearGrinder:GetWeeklyResetDay(realm)

	-- number is index into day of week; 1 == Sunday
	local resets = { 
		enCN = 3, enUS = 3, esMX = 3, ptBR = 3,                                   -- Tuesday 
		deDE = 4, enGB = 4, esES = 4, frFR = 4, itIT = 4, ptPT = 4, ruRU = 4,     -- Wednesday
		enTW = 5, koKR = 5, zhCN = 5, zhTW = 5,                                   -- Thursday
	}
	local reset;
	
	if realm == nill then

		local locale = GetLocale()
		reset = resets[locale]

		--if not reset then GearGrinder:Print(locale, "locale is not recognized, please report this error") end
		return reset or (self:GetResetDayOfWeek() + 1)
	else
		-- use saved realm locale's reset day
		if GG_Storage[realm] == nil then return (self:GetResetDayOfWeek() + 1) end; -- issue so just return the default value
		firstalt = GG_Storage[realm][1];
		if firstalt == nil then return (self:GetResetDayOfWeek() + 1) end; -- issue so just return the default value
		reset = resets[GG_Storage[realm][1].locale]
		return reset or (self:GetResetDayOfWeek() + 1)
	end
end

function GearGrinder:GetNextDailyReset(realm, toon)
	-- when first logging in, we may get a bogus result from GetQuestResetTime
	-- if thats the case, then just return math.huge so that nothing gets purged
	if realm == nil or toon == nil then
		-- use current realm
		local qrtime = GetQuestResetTime()
		if qrtime <= 0 then
			return math.huge
		end

		return time() + qrtime
	else
		-- use saved realm locale's reset time
		if GG_Storage[realm] == nil then return math.huge end; -- issue so just return a huge number
		if GG_Storage[realm][toon] == nil then return math.huge end; -- issue so just return a huge number

		maxReset = GG_Storage[realm][toon].timeDailyReset;
		
		if time() > maxReset then
			-- calculate the next reset > time()
			x = time() - maxReset;
			x = math.floor(x / 86400)+1;
			return maxReset + x * 86400;
		else
			return maxReset;
		end
		
	end
end

function GearGrinder:GetNextWeeklyReset(realm, toon)
	-- if we're not getting a valid number for the daily reset, then we can't
	-- calculate the weekly. just return hugeNumber so that nothing gets purged 
	local nextDailyReset = self:GetNextDailyReset(realm, toon)
	if (nextDailyReset == math.huge) then
		return math.huge
	end

	local dayOfNextReset = date("*t", nextDailyReset).wday
	local daysToWeeklyReset = math.fmod(7 + self:GetWeeklyResetDay(realm) - dayOfNextReset, 7)
	local nextWeeklyReset = nextDailyReset + (daysToWeeklyReset * 86400) -- 86400 is number of seconds in a day (24 * 60 * 60)

	return nextWeeklyReset
end

function GearGrinder:GenerateSortedDBIndex()
	local idx = {};

	self.sortedDbIdx = {}; 
	if self.sortedDbIdx == nil or #self.sortedDbIdx == 0 then 
		self.sortedDbIdx = {}; 

		-- insert current toon first.
		idx = self.sortedDbIdx;
		local num;

		--table.insert(idx, {name=self.currentPlayer, realm=self.currentRealm});

		for r, alts in pairs(GG_Storage) do
			for t, alt in pairs(alts) do
				val = {name=t, realm=r};
				
				num = 1;
				
				if self:GetToonRealmGroup() then
					val["sort" .. num] = r;
					val["sort" .. num .. "order"] = 1;
					num = num + 1;
				end

				if self:GetSortOrder() == 1 then  -- Level -> iLevel
					val["sort" .. num] = alt.lvl;
					val["sort" .. num .. "order"] = 2;
					num = num + 1;
					
					val["sort" .. num] = alt.iLvl;
					val["sort" .. num .. "order"] = 2;
					num = num + 1;					

					val["sort" .. num] = t;
					val["sort" .. num .. "order"] = 1;
					num = num + 1;
					
					if not self:GetToonRealmGroup() then
						val["sort" .. num] = r;
						val["sort" .. num .. "order"] = 1;
						num = num + 1;
					end
					
				end

				if self:GetSortOrder() == 2 then  -- Character Name
					val["sort" .. num] = t;
					val["sort" .. num .. "order"] = 1;
					num = num + 1;
					
					if not self:GetToonRealmGroup() then
						val["sort" .. num] = r;
						val["sort" .. num .. "order"] = 1;
						num = num + 1;
					end
					
				end

				if self:GetSortOrder() == 3 then  -- Class -> Character Name
					val["sort" .. num] = alt.class;
					val["sort" .. num .. "order"] = 1;
					num = num + 1;
					
					val["sort" .. num] = t;
					val["sort" .. num .. "order"] = 1;
					num = num + 1;
					
					if not self:GetToonRealmGroup() then
						val["sort" .. num] = r;
						val["sort" .. num .. "order"] = 1;
						num = num + 1;
					end
				end

				if self:GetSortOrder() == 5 then  -- iLevel
					val["sort" .. num] = alt.iLvl;
					val["sort" .. num .. "order"] = 2;
					num = num + 1;					

					val["sort" .. num] = t;
					val["sort" .. num .. "order"] = 1;
					num = num + 1;
					
					if not self:GetToonRealmGroup() then
						val["sort" .. num] = r;
						val["sort" .. num .. "order"] = 1;
						num = num + 1;
					end
					
				end
				
				if not table.contains(idx, val) then
					table.insert(idx, val);
				end
			end
		end
	end

	-- sort the table incase the sort order has changed.
	table.sort(idx, function(a,b) 

		local levels;

		if a.sort4 ~= nil then
			levels = 4;
		elseif a.sort3 ~= nil then
			levels = 3;
		elseif a.sort2 ~= nil then
			levels = 2;
		else
			levels = 1;
		end
		
		for i=1, levels-1 do
			if a["sort" .. i] == b["sort" .. i] then
				if i == levels-1 then
					-- return next level
					if a["sort" .. i+1 .. "order"] == 1 then
						return a["sort" .. i+1] < b["sort" .. i+1]
					else
						return a["sort" .. i+1] > b["sort" .. i+1]
					end
				else
					-- progress to next loop
				end
			else
				if a["sort" .. i .. "order"] == 1 then
					return a["sort" .. i] < b["sort" .. i]
				else
					return a["sort" .. i] > b["sort" .. i]
				end				
			end		
		end
		
	end);

end

function GearGrinder:ToonNameColored(realm,toon,class)
	local toonColor, toonText = "", ""

	toonColor = CLASS_COLOR[class]
	if self:GetToonShowRealm() then
		toonText = toonColor .. " " .. toon .. '-' .. realm .. END_COLOR;
	else
		toonText = toonColor .. " " .. toon .. END_COLOR;
	end

	return toonText
end

function GearGrinder:GetTooltipColumns()
	local nBoss, nRaid, nToon, nGarrison = 0, 0, 0, 0; -- Columns for each section
	
	-- Boss Count
	if self:GetWorldBoss() then
		for i, v in pairs(WORLD_BOSSES) do
			if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
				nBoss = nBoss + 1
			end
		end
	end
	
	-- Raid Count
	if self:GetRaid() then
		for i, v in pairs(RAID_COLUMNS) do
			if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
				nRaid = nRaid + 1
			end
		end
	end

	-- Garrison Count
	for i, v in pairs(GARRISON_COLUMNS) do
		if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
			nGarrison = nGarrison + 1
		end
	end	

	-- Toon Count
	for i, v in pairs(CHAR_COLUMNS) do
		if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
			nToon = nToon + 1
		end
	end	
	
	-- Get the max of the values
	-- raid section now has boss and raids
	x = nBoss + nRaid

	-- larger of raid section or garrison section
	x = (x + nGarrison + abs(x - nGarrison)) / 2
	
	-- larger of largest above or toon section
	x = ((x + nToon + abs(x - nToon)) / 2) 

	return x + 1  -- add one column for the character name
	
end

function GearGrinder:LoadAltRaid(tt)
	local col = 2;

	line = tt:AddHeader(L.core.LFRTitle);

	if self:GetRaid() then
		for i, v in pairs(RAID_COLUMNS) do
			if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
				tt:SetCell(line, col, v.title, v.justify)
				col = col + 1
			end
		end
	end
		
	if self:GetWorldBoss() then
		for i, v in pairs(WORLD_BOSSES) do
			if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
				tt:SetCell(line, col, v.title, v.justify)
				col = col + 1
			end
		end
	end

	-- build a list of toons
	self:GenerateSortedDBIndex(); 

	altline = false;
	lastRealm = "";
	for i = 1, #self.sortedDbIdx do
		if self:GetToonRealm() or (self.sortedDbIdx[i].realm == self.currentRealm) then
			line = self:ShowAltRaid(self.sortedDbIdx[i].realm, self.sortedDbIdx[i].name, tt, altline, lastRealm);
			if line then
				-- reset the altline since it was a non-alt line that was printed.
				if self:GetToonRealmGroup() and self.sortedDbIdx[i].realm ~= lastRealm then
					altline = false;
				end
				altline = self:GetAltLine() and not altline;
				lastRealm = self.sortedDbIdx[i].realm;
			end
		end
	end

end

function GearGrinder:ShowAltRaid(realm, toon, tt, altline, lastRealm)
	local toonText = "";
	local cellText = "";
	local col = 0;
	local boss = {};
	local showtoon;
	
	local alt = GG_Storage[realm][toon];

	-- toon should not be nil by this stage.
	if alt == nil then return nil end;

	local dungeons = {};
	local saves = {};
	
	--self:PopulateRAIDNAMES()
	
	if alt.active == nil then alt.active = true end
	if self:GetFiltering() and alt.active == false then return nil end  -- exit function if the toon is not active
	
	-- by default the toon is not shown
	showtoon = false;

	-- if the data has not been saved then ignore
	if alt.dungeon == nil then return nil end

	local dtPrev = self:GetNextWeeklyReset(realm, toon) - (7 * 24 * 60 * 60);

	-- setup the boss array
	for i, v in pairs(WORLD_BOSSES) do
		
		if (alt.worldboss and alt.worldboss[v.name]) then
			-- we have a save entry
			if alt.worldboss[v.name].resetTime <= dtPrev then
				-- if the save is old.. then not killed this week
				boss[v.ID] = false;
			else
				-- if a recent save then it is killed.
				boss[v.ID] = true;
			end
		else
			-- try with the quest.
			if (alt.quest and alt.quest[v.quest]) then
				-- we have a save entry
				if alt.savingTime <= dtPrev then
					-- if the save is old.. then not killed this week
					boss[v.ID] = false;
				else
					-- if a recent save then it is killed.
					boss[v.ID] = true;
				end
			else		
				-- no save so not killed
				boss[v.ID] = false;
			end
		end

		-- if a world boss has been killed then show the toon
		if boss[v.ID] and v.visible() then showtoon = true end

	end

	-- check the reset time and initialise accordingly
	if dtPrev < alt.savingTime then
		-- use the data in the database
		dungeons = alt.dungeon;
	else
		--ignore the data in the database
		for i, v in pairs(alt.dungeon) do
			dungeons[i] = {};
			dungeons[i].isComplete = 0;
			dungeons[i].qtyLooted = 0;
			dungeons[i].isAvailable = v.isAvailable;
		end
	end

	-- if the any of the visible LFR's are available then show the toon
	if not showtoon then
		for i, v in pairs(RAID_COLUMNS) do  -- loop through the raids
			if v.visible() and v.xpac <= self:GetXpac() and not showtoon then  -- but only if we are not showing the toon
				local tbl;

				-- need to check if toon can do it
				tbl = self:GetDungeonIdsForInstance(v.instanceName);  -- get the DungeonIds for the LFR

				for i = 1, #tbl do
					v = tbl[i];
					if dungeons[v] and dungeons[v].isAvailable ~= nil then
						if dungeons[v].isAvailable == 1 then
							showtoon = true; -- if available then show the toon
						end
					end
				end
			end
		end
	end

	-- if not showing the toon then exit
	if not showtoon then return nil end;

	-- check the reset time on the instances and reset accordingly
	for i, v in pairs(alt.saves) do
		if v.resetTime > time() then
			saves[i] = {};
			saves[i].ID = v.ID;
			saves[i].difficultyID = v.difficultyID;
			saves[i].instanceName = v.instanceName;
			saves[i].instanceID = v.instanceID;
			saves[i].maxPlayers = v.maxPlayers;
			saves[i].difficultyName = v.difficultyName;
			saves[i].numKilled = v.numKilled;
			saves[i].numBoss = v.numBoss;
			saves[i].resetTime = v.resetTime;
		end
	end


	-- Add a group header
	if self:GetToonRealmGroup() and realm ~= lastRealm then
		line = tt:AddLine('|cFFAAAAAA-= ' .. realm .. ' =-|r');
	end

	toonText = self:ToonNameColored(realm, toon, alt.class);
	line = tt:AddLine(toonText)

	col = 2
	if altline then
		-- override the alternate line if it is a new realm group
		if (self:GetToonRealmGroup() and realm == lastRealm) or not self:GetToonRealmGroup() then
			tt:SetLineColor(line, self:GetAltLineColor())
		end
	end

	for i, v in pairs(RAID_COLUMNS) do
		if v.visible() and v.xpac <= self:GetXpac() then
			colTxt = self:GetRaidCellValue(v.instanceName, dungeons, saves)
			tt:SetCell(line, col, colTxt, v.justify);
			col = col + 1
		end
	end

	-- show the world boss kills
	if self:GetWorldBoss() then
		for i, v in pairs(WORLD_BOSSES) do
			if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
				if boss[v.ID] then 
					bossText = RED_NEON_COLOR .. L.core.BossLooted .. END_COLOR
				else 
					bossText = GREEN_NEON_COLOR .. L.core.BossNotLooted .. END_COLOR 
				end
				tt:SetCell(line, col, bossText, v.justify);
				col = col + 1
			end
		end
	end

	return line
	
end

function GearGrinder:LoadAltGarrison(tt)
	local col = 2;

	line = tt:AddHeader(L.core.Garrison_Title);

	for i, v in pairs(GARRISON_COLUMNS) do
		if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
			tt:SetCell(line, col, v.title, v.justify)
			col = col + 1
		end
	end

	-- build a list of toons
	self:GenerateSortedDBIndex(); 

	altline = false;
	lastRealm = "";
	for i = 1, #self.sortedDbIdx do
		if self:GetToonRealm() or (self.sortedDbIdx[i].realm == self.currentRealm) then
			line = self:ShowAltGarrison(self.sortedDbIdx[i].realm, self.sortedDbIdx[i].name, tt, altline, lastRealm);
			if line then
				-- reset the altline since it was a non-alt line that was printed.
				if self:GetToonRealmGroup() and self.sortedDbIdx[i].realm ~= lastRealm then
					altline = false;
				end
				altline = self:GetAltLine() and not altline;
				lastRealm = self.sortedDbIdx[i].realm;
			end
		end
	end

end

function GearGrinder:ShowAltGarrison(realm, toon, tt, altline, lastRealm)
	local toonText = "";
	local cellText = "";
	local col = 0;
	
	local alt = GG_Storage[realm][toon];

	-- toon should not be nil by this stage.
	if alt == nil then return nil end;

	if alt.active == nil then alt.active = true end
	if self:GetFiltering() and alt.active == false then return nil end  -- exit function if the toon is not active
	
	-- if the data has not been saved then ignore
	if alt.garrison == nil then return nil end
	
	-- if the toon has no garrison level then ignore
	if alt.garrison.level == nil then return nil end
	
	--local dtPrev = self:GetNextWeeklyReset(realm, toon) - (7 * 24 * 60 * 60);

	-- Add a group header
	if self:GetToonRealmGroup() and realm ~= lastRealm then
		line = tt:AddLine('|cFFAAAAAA-= ' .. realm .. ' =-|r');
	end

	toonText = self:ToonNameColored(realm, toon, alt.class);
	line = tt:AddLine(toonText)

	col = 2
	if altline then
		-- override the alternate line if it is a new realm group
		if (self:GetToonRealmGroup() and realm == lastRealm) or not self:GetToonRealmGroup() then
			tt:SetLineColor(line, self:GetAltLineColor())
		end
	end

	for i, v in pairs(GARRISON_COLUMNS) do
		if v.visible() and v.xpac <= self:GetXpac() then
			colTxt = v.value(realm, toon);
			tt:SetCell(line, col, colTxt, v.justify);
			col = col + 1
		end
	end

	return line
	
end

function GearGrinder:LoadAlt(tt)
	local col = 2
	
	line = tt:AddHeader(L.core.PDCharTextShort);

	for i, v in pairs(CHAR_COLUMNS) do
		if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
			tt:SetCell(line, col, v.title, v.justify)
			col = col + 1
		end
	end
	
	-- build a list of toons
	self:GenerateSortedDBIndex(); 

	altline = false;
	lastRealm = "";
	for i = 1, #self.sortedDbIdx do
		if self:GetToonRealm() or (self.sortedDbIdx[i].realm == self.currentRealm) then
			line = self:ShowAlt(self.sortedDbIdx[i].realm, self.sortedDbIdx[i].name, tt, altline, lastRealm)
			if line then
				-- reset the altline since it was a non-alt line that was printed.
				if self:GetToonRealmGroup() and self.sortedDbIdx[i].realm ~= lastRealm then
					altline = false;
				end
				altline = self:GetAltLine() and not altline;
				lastRealm = self.sortedDbIdx[i].realm;
			end
		end
	end
	
end

function GearGrinder:ShowAlt(realm, toon, tt, altline, lastRealm)

	local toonText, col, line, i, v; 
	local alt = GG_Storage[realm][toon];

	-- alt should not be nil by this stage
	if alt == nil then return nil end;

	if alt.active == nil then alt.active = true end
	if self:GetFiltering() and alt.active == false then return nil end  -- exit function if the toon is not active
	
	if alt.lvl == nil then alt.lvl = 0 end
	if alt.iLvl == nil then alt.iLvl = 0 end
	if alt.iELvl == nil then alt.iELvl = 0 end

	-- Add a group header
	if self:GetToonRealmGroup() and realm ~= lastRealm then
		line = tt:AddLine('|cFFAAAAAA-= ' .. realm .. ' =-|r')
	end

	-- Add the line
	toonText = self:ToonNameColored(realm, toon, alt.class);
	line = tt:AddLine(toonText);

	col = 2
	if altline then
		-- override the alternate line if it is a new realm group
		if (self:GetToonRealmGroup() and realm == lastRealm) or not self:GetToonRealmGroup() then
			tt:SetLineColor(line, self:GetAltLineColor())
		end
	end

	-- add the columns
	for i, v in pairs(CHAR_COLUMNS) do
		if v.visible() and v.xpac <= self:GetXpac() then  -- should it be shown
			local txt = v.value(realm, toon)
			tt:SetCell(line, col, txt, v.justify);
			col = col + 1
		end
	end

	return line
	
end

-------------------------
--- Garrison TT Values
function GearGrinder:GetTTGarValue(realm, toon, idx)

	-- no daily resetting required
	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	-- garrison data
	local gar = data.garrison;

	-- value must exist by this stage
	if gar == nil then return end;

	return gar[idx];

end

function GearGrinder:GetTTGarMissionValue(realm, toon)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	local gar = data.garrison;

	-- value must exist by this stage
	if gar == nil then return end;

	garm = gar.missions;

	local txt = "";
	local numComplete, numInprogress = 0, 0;
	local theTime = time();

	-----------------------------
	-- showing counts of missions
	--  Complete (yellow)
	--  Inprogress (red)

	-- mission data
	--   missionID
	--   numFollowers
	--   duration       in seconds
	--   timeLeft       text string
	--   startTime      in seconds
	-----------------------------

	for i, v in pairs(garm) do
		if v.startTime + v.duration > theTime then
			-- in progress
			numInprogress = numInprogress + 1;
		else
			-- complete
			numComplete = numComplete + 1;
		end 
	end
	
	txt = YELLOW_NEON_COLOR .. numComplete .. " " .. RED_NEON_COLOR .. numInprogress .. END_COLOR;

	return txt

end

function GearGrinder:GetTTGarShipmentValue(realm, toon)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	local gar = data.garrison;

	-- value must exist by this stage
	if gar == nil then return end;

	gars = gar.shipments;

	local txt = "";
	local numAvailable, numComplete, numInprogress, numCapacity = 0, 0, 0, 0;
	local theTime = time();

	-----------------------------
	-- showing counts of shipments
	--  Available (green)
	--  Complete/Not collected (yellow)
	--  Inprogress (red)

	-- shipment data
	--   name
	--   buildingID
	--   shipmentCapacity
	--   shipmentsReady
	--   shipmentsTotal
	--   creationTime
	--   duration
	--   itemName
	--   itemID
	-----------------------------
	-- notes:
	--    need to calculate the numbers as increments
	-----------------------------
	for i, v in pairs(gars) do
		local capacity, total, ready = (v.shipmentCapacity or 0), (v.shipmentsTotal or 0), (v.shipmentsReady or 0);
		-- adjust the total to cater for those already 'ready'.
		total = total - ready;
		-- calcualte the ready qty.
		local workTime = v.creationTime;  -- seed the start time
		for i=1, total do
			if workTime + v.duration <= theTime then
				-- ready
				ready = ready + 1;
			end
			workTime = workTime + v.duration;
		end 
		
		numCapacity = numCapacity + capacity 
		numAvailable = numAvailable + (capacity - (v.shipmentsTotal or 0));
		numComplete = numComplete + (ready);
		numInprogress = numInprogress + ((v.shipmentsTotal or 0) - ready);
	end

	
	txt = GREEN_NEON_COLOR .. numAvailable .. " " .. YELLOW_NEON_COLOR .. numComplete .. " " .. RED_NEON_COLOR .. numInprogress .. END_COLOR;

	return txt

end

function GearGrinder:GetTTGarActivityValue(realm, toon)

	local data = GG_Storage[realm][toon];

	local dtPrev = self:GetNextDailyReset(realm, toon) - (24 * 60 * 60);

	-- value must exist by this stage
	if data == nil then return end;

	local gar = data.garrison;

	-- value must exist by this stage
	if gar == nil then return end;

	garsp = gar.spell;
	garb = gar.buildings;

	local txt = "";
	local txtM, txtH = "", "";
	local theTime = time();

	-----------------------------
	-- showing counts of shipments
	--  M - Mine (red or green)
	--  H - Herb (red or green)

	-- Spell data
	--   each entry is a time the spell was cast
	-----------------------------
	
	-- Mine
	if self:GetGarrisonActivityMine() then
		-- has bulding?
		if self:AltHasBuilding(garb, "Mine") then
			if garsp == nil or (garsp and garsp["Mine"] == nil) then -- has building but no record of use
				-- Green
				txtM = GREEN_NEON_COLOR
			else
				if garsp["Mine"] <= dtPrev then
					-- Green (did the mining yesterday)
					txtM = GREEN_NEON_COLOR 
				else -- Red (done the mining)
					txtM = RED_NEON_COLOR 
				end
			end
		else
			-- grey
			txtM = GREY_COLOR
		end

		txtM = txtM .. "M "
	end

	-- Herb
	if self:GetGarrisonActivityHerb() then
		-- has bulding?
		if self:AltHasBuilding(garb, "Herb") then
			if garsp == nil or (garsp and garsp["Herb"] == nil) then -- has building but no record of use
				-- Green
				txtH = GREEN_NEON_COLOR
			else
				if garsp["Herb"] <= dtPrev then
					-- Green (did the herbing yesterday)
					txtH = GREEN_NEON_COLOR 
				else -- Red (done the herbing)
					txtH = RED_NEON_COLOR 
				end
			end
		else
			-- grey
			txtH = GREY_COLOR
		end

		txtH = txtH .. "H "
	end

	txt = txtM .. txtH .. END_COLOR

	return txt

end

function GearGrinder:AltHasBuilding(garb, buildingShortName)

	if garb == nil then return end;

	for i, v in pairs(garb) do

		if GARRISON_BUILDING[v.buildingID] and GARRISON_BUILDING[v.buildingID] == buildingShortName then
			return true
		end
	end

	return false

end

function GearGrinder:GetTTGarFollowerValue(realm, toon)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	local gar = data.garrison;

	-- value must exist by this stage
	if gar == nil then return end;

	garf = gar.followers;
	garm = gar.missions;
	garb = gar.buildings;

	local txt = "";
	local numAvailable, numComplete, numInprogress = 0, 0, 0;
	local theTime = time();

	-----------------------------
	-- showing counts of followers
	--  Available (green)
	--  Complete/Not actioned (yellow)
	--  Inprogress (red)

	-- follower data
	--   followerID
	--   level
	--   garrFollowerID
	--   quality
	--   levelXP
	-----------------------------
	-- notes:
	--    need to calculate the numbers of inprogress/completed missions and building assignments
	-----------------------------
	local nTotal, nMissionComplete, nMissionInprogress, nBuilding = 0, 0, 0, 0;

	-- how many assigned to buildings
	for i, v in pairs(garf) do
		nTotal = nTotal + 1;   -- #garf not working..hmmm
	end

	-- how many assigned to buildings
	for i, v in pairs(garb) do
		if v.followerID then
			nBuilding = nBuilding + 1;
		end
	end

	-- how many on missions
	for i, v in pairs(garm) do
		if v.startTime + v.duration > theTime then
			-- in progress
			nMissionInprogress = nMissionInprogress + v.numFollowers;
		else
			-- complete
			nMissionComplete = nMissionComplete + v.numFollowers;
		end 
	end
	
	numAvailable = nTotal - nMissionInprogress - nMissionComplete - nBuilding;
	numComplete = nMissionComplete;
	numInprogress = nBuilding + nMissionInprogress;

	txt = GREEN_NEON_COLOR .. numAvailable .. " " .. YELLOW_NEON_COLOR .. numComplete .. " " .. RED_NEON_COLOR .. numInprogress .. END_COLOR;

	return txt

end

function GearGrinder:GetTTGarBuildingValue(realm, toon)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	local gar = data.garrison;

	-- value must exist by this stage
	if gar == nil then return end;

	garb = gar.buildings;

	local txt = "";
	local numAvailable, numComplete, numInprogress = 0, 0, 0;
	local theTime = time();

	-----------------------------
	-- showing counts of buildings
	--  Active (green)
	--  Building/Upgrade Complete and not activated (yellow)
	--  Building Inprogress (red)
	--  Empty Plots (orange)?

	-- building data
	--   plotID
	--   buildingID
	--   name
	--   rank
	--   hasFollowerSlot
	--   isBuilding         Building/upgrading in progress
	--   startTime			start time of the build/upgrade
	--   buildDuration		duration of the build/upgrade
	--   followerID
	-----------------------------
	-- notes:
	--    n/a
	-----------------------------
	local nTotal = 0;
	
	-- how many of each?
	for i, v in pairs(garb) do
		nTotal = nTotal + 1;
		if v.isBuilding then  -- if not bulding then it's active
			-- building in progress  check if complete or still going
			if v.startTime + v.buildDuration <= theTime then
				numComplete = numComplete + 1;
			else
				numInprogress = numInprogress + 1;
			end
		end
	end

	numAvailable = nTotal - numComplete - numInprogress;

	txt = GREEN_NEON_COLOR .. numAvailable .. " " .. YELLOW_NEON_COLOR .. numComplete .. " " .. RED_NEON_COLOR .. numInprogress .. END_COLOR;

	return txt

end

-------------------------
--- Character TT values

function GearGrinder:GetTTCharValue(realm, toon, idx)

	-- no daily resetting required
	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	return data[idx];

end


function GearGrinder:GetTTCurrencyValue(realm, toon, currency)

	-- no daily resetting required
	local data = GG_Storage[realm][toon];


	-- value must exist by this stage
	if data == nil then return end;

	if data.currency and data.currency[currency] then
		local qty = data.currency[currency].qty or 0;
		local qtyMax = data.currency[currency].qtyMax or 0;
		local color;

		if qtyMax and qtyMax > 0 then
			-- set the color by an 10% off max
			color = self:GetProgressColor(qty, qtyMax, math.floor(qtyMax*0.1))
		else
			-- use green
			color = GREEN_NEON_COLOR
		end
		
		return color .. qty .. END_COLOR 

	else
		return ""
	end

end

function GearGrinder:GetTTCurrencyEarnValue(realm, toon, currency)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	-- will need to reset the weekly earning
	local dtPrev = self:GetNextWeeklyReset(realm, toon) - (7 * 24 * 60 * 60);

	if data.currency and data.currency[currency] then
		local wkEarn, wkMax = 0, data.currency[currency].wkMax;
		local color;

		if dtPrev < data.savingTime then 
			wkEarn = data.currency[currency].wkEarn;
		end

		if wkMax and wkMax > 0 then
			-- set the color by an 10% off max
			local interval = math.floor(wkMax*0.1);
			if interval <= 0 then interval = 1 end;
			color = self:GetProgressColor(wkEarn, wkMax, interval)
		else
			-- use green
			color = GREEN_NEON_COLOR
		end
		
		return color .. wkEarn .. END_COLOR 

	else
		return ""
	end

end

function GearGrinder:GetTTCharCharmValue(realm, toon)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	-- need to reset/check the numFateQuests
	local dtPrev = self:GetNextWeeklyReset(realm, toon) - (7 * 24 * 60 * 60);

	local txt = ""
		
	-- Lesser Charms
	if self:GetCharmLesser() then
		txt = txt .. self:GetTTCurrencyValue(realm, toon, CURRENCIES.LESSER) .. " "
	end
		
	-- Elder Charms
	if self:GetCharmElder() then
		txt = txt .. self:GetTTCurrencyValue(realm, toon, CURRENCIES.ELDER) .. " "
	end
		
	-- Mogu Runes
	if self:GetCharmMogu() then
		txt = txt .. self:GetTTCurrencyValue(realm, toon, CURRENCIES.MOGU) .. " "
	end
		
	-- Warforged Seal
	if self:GetCharmWarSeal() then
		txt = txt .. self:GetTTCurrencyValue(realm, toon, CURRENCIES.WARSEAL) .. " "
	end
		
	if self:GetXpac() > 4 then
		-- Seal of Tempered Fate
		if self:GetCharmFate() then
			local qty = data.currency[CURRENCIES.FATE].qty or 0;
			local qtyMax = data.currency[CURRENCIES.FATE].qtyMax or 0;
			local color;
			local numFateQuests = 0;

			if dtPrev < data.savingTime then 
				numFateQuests = (
					(data.quest[QUESTS["qFateA1"]] and 1 or 0) +  (data.quest[QUESTS["qFateA2"]] and 1 or 0) +	(data.quest[QUESTS["qFateA3"]] and 1 or 0) + 
					(data.quest[QUESTS["qFateG1"]] and 1 or 0) +  (data.quest[QUESTS["qFateG2"]] and 1 or 0) +	(data.quest[QUESTS["qFateG3"]] and 1 or 0) +
					(data.quest[QUESTS["qFateH1"]] and 1 or 0) +  (data.quest[QUESTS["qFateH2"]] and 1 or 0) +	(data.quest[QUESTS["qFateH3"]] and 1 or 0) +
					(data.quest[QUESTS["qFateGR1"]] and 1 or 0) + (data.quest[QUESTS["qFateGR2"]] and 1 or 0) + (data.quest[QUESTS["qFateGR3"]] and 1 or 0)
				);
			end

			if qty >= qtyMax and qtyMax > 0 then
				color = RED_NEON_COLOR
			else
				-- color by quest hand-ins
				color = self:GetProgressColor(numFateQuests, 3, 1)
				if color == RED_NEON_COLOR then
					color = EPIC_COLOR
				end
			end
			txt = txt .. color .. qty .. " " .. END_COLOR;
		end
	end
	
	return txt

end

function GearGrinder:GetTTCharFarmValue(realm, toon)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	-- need to reset/check the numFateQuests
	local dtDailyPrev = self:GetNextWeeklyReset(realm, toon) - (24 * 60 * 60);

	local txt = ""
		
	if data.farmSize and data.farmSize > 0 then
		local farmSow, farmHarvest, farmSow;

		-- setup the numbers for display.
		-- consider a reset from when data was last saved.
		if data.farmTime <= dtDailyPrev then
			farmSow = 0
			farmHarvest = data.farmHarvest + data.farmSow
			if farmHarvest > data.farmSize then farmHarvest = data.farmSize end
		else
			farmSow = data.farmSow
			farmHarvest = data.farmHarvest
		end
		farmToDo = data.farmSize - farmHarvest - farmSow
		
		txt = YELLOW_NEON_COLOR .. farmToDo .. " " .. RED_NEON_COLOR .. farmSow .. " " .. GREEN_NEON_COLOR .. farmHarvest .. END_COLOR
	end

	return txt

end

function GearGrinder:GetTTCharProfCDValue(realm, toon)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	local txt = "";
	local i, v;
		
	if data.trade then 
		for i, v in pairs(TRADE_SKILLS) do
			if data.trade[i] then
				if v.visible() then -- should the value be visible?
					if data.trade[i] <= time() then
						txt = txt .. GREEN_NEON_COLOR
					else
						txt = txt .. RED_NEON_COLOR
					end
					txt = txt .. v.title .. " "
				end
			end
		end
		if txt ~= "" then txt = txt .. END_COLOR end
	end
		
	return txt

end

function GearGrinder:GetTTCharActivityValue(realm, toon)

	local data = GG_Storage[realm][toon];

	-- value must exist by this stage
	if data == nil then return end;

	-- need to reset/check the numFateQuests
	local dtPrev = self:GetNextWeeklyReset(realm, toon) - (7 * 24 * 60 * 60);
	local dtDailyPrev = self:GetNextDailyReset(realm, toon) - (24 * 60 * 60);

	local txt = "";
	local tbl = {};
		
	tbl["D"] = {ID = "D", visible = function() return self:GetActivityD() end,};
	tbl["H"] = {ID = "H", visible = function() return self:GetActivityH() end,};

	-- MoP only activities
	if self:GetXpac() == 4 then
		tbl["S"] = {ID = "S", visible = function() return self:GetActivityS() end,};
		tbl["HS"] = {ID = "HS", visible = function() return self:GetActivityHS() end,};
	end

	-- WoD activities
	if self:GetXpac() > 4 then
		tbl["C"] = {ID = "C", visible = function() return self:GetActivityC() end,};
		tbl["R"] = {ID = "R", visible = function() return self:GetActivityR() end,};
	end
	
	table.sort(tbl, function(a,b) 
		return a.ID < b.ID
	end);
	
	if self:GetXpac() > 4 then
		tbl["D"].avail = function() return data.dungeon[DUNGEONIDS["WoD_D"]] and data.dungeon[DUNGEONIDS["WoD_D"]].isAvailable end;
		--tbl["S"].avail = function() return data.dungeon[DUNGEONIDS["WoD_S"] ] and data.dungeon[DUNGEONIDS["WoD_S"] ].isAvailable end;
		tbl["H"].avail = function() return data.dungeon[DUNGEONIDS["WoD_H"] ] and data.dungeon[DUNGEONIDS["WoD_H"] ].isAvailable end;
		--tbl["HS"].avail = function() return data.dungeon[DUNGEONIDS["WoD_HS"] ] and data.dungeon[DUNGEONIDS["WoD_HS"] ].isAvailable end;
	else
		tbl["D"].avail = function() return data.dungeon[DUNGEONIDS["D"]] and data.dungeon[DUNGEONIDS["D"]].isAvailable end;
		tbl["S"].avail = function() return data.dungeon[DUNGEONIDS["S"] ] and data.dungeon[DUNGEONIDS["S"] ].isAvailable end;
		tbl["H"].avail = function() return data.dungeon[DUNGEONIDS["H"] ] and data.dungeon[DUNGEONIDS["H"] ].isAvailable end;
		tbl["HS"].avail = function() return data.dungeon[DUNGEONIDS["HS"] ] and data.dungeon[DUNGEONIDS["HS"] ].isAvailable end;
	end

	if dtDailyPrev < data.savingTime then
		local prefix = "";
		if self:GetXpac() > 4 then
			tbl["D"].value = data.dungeon[DUNGEONIDS["WoD_D"]] and data.dungeon[DUNGEONIDS["WoD_D"] ].isComplete
			tbl["H"].value = data.dungeon[DUNGEONIDS["WoD_H"]] and data.dungeon[DUNGEONIDS["WoD_H"] ].isComplete
			tbl["C"].value = ((data.quest[QUESTS["qC1"] ] or data.quest[QUESTS["qC2"] ] or data.quest[QUESTS["qC3"] ] or data.quest[QUESTS["qC4"] ] or data.quest[QUESTS["qC5"] ] or data.quest[QUESTS["qC6"] ] or data.quest[QUESTS["qC7"] ] or data.quest[QUESTS["qC8"] ] or data.quest[QUESTS["qC9"] ] or data.quest[QUESTS["qC10"] ] or data.quest[QUESTS["qC11"] ] or data.quest[QUESTS["qC12"] ] or data.quest[QUESTS["qC13"] ] or data.quest[QUESTS["qC14"] ] or data.quest[QUESTS["qC15"] ] or data.quest[QUESTS["qC16"] ])) and 1 or 0
			tbl["R"].value = ((data.quest[QUESTS["qRoB1"] ] or data.quest[QUESTS["qRoB2"] ] or data.quest[QUESTS["qRoB3"] ] or data.quest[QUESTS["qRoB4"] ] or data.quest[QUESTS["qRoB5"] ])) and 1 or 0
		else
			tbl["D"].value = data.dungeon[DUNGEONIDS["D"]] and data.dungeon[DUNGEONIDS["D"] ].isComplete
			tbl["S"].value = data.dungeon[DUNGEONIDS["S"]] and data.dungeon[DUNGEONIDS["S"] ].isComplete
			tbl["H"].value = data.dungeon[DUNGEONIDS["H"] ] and data.dungeon[DUNGEONIDS["H"] ].isComplete
			tbl["HS"].value = data.dungeon[DUNGEONIDS["HS"] ] and data.dungeon[DUNGEONIDS["HS"] ].isComplete
		end
	end
		
	for i,v in pairs(tbl) do
		--v = tbl[i];
		if v.visible and v.visible() then
			if v.avail and v.avail() == 1 then
				if v.value and v.value == 1 then
					color = RED_NEON_COLOR
				else
					color = GREEN_NEON_COLOR
				end
			else
				color = GREY_COLOR
			end
			txt = txt .. color .. v.ID .. " "
		end
	
	end

	if txt ~= "" then txt = txt .. END_COLOR end

	return txt

end

function GearGrinder:GetDungeonIdsForInstance(instanceName)
	local tbl;

	tbl = {};
	for i = 1, GetNumRFDungeons() do
		local dungeonID = GetRFDungeonInfo(i);
		local _, _, hlink = GetDungeonInfo(dungeonID);
		
		if hlink then
			idx = string.find(hlink, instanceName);
			if idx and idx > 0 then
				-- we have a match
				table.insert(tbl, dungeonID)
			end	
		end
	end

	return tbl

end


function GearGrinder:GetRaidCellValue(instanceName, dungeons, saves)
	local tbl, idx, i, txt, txtLFR, txtNormal, txtHeroic, txtMythic;

	txt, txtLFR, txtNormal, txtHeroic, txtMythic = "", "", "", "", ""

	------------
	-- LFR's	-- carefully find the LFR Dungeon ID's
	if self:GetRaidLFR() then
		tbl = self:GetDungeonIdsForInstance(instanceName);

		for i = 1, #tbl do
			v = tbl[i];
			if txtLFR ~= "" then txtLFR = txtLFR .. " " end
			if dungeons[v] and dungeons[v].isAvailable ~= nil then
				if dungeons[v].isAvailable == 1 then
					if dungeons[v].isComplete == 1 then
						-- red text
						txtLFR = txtLFR .. RED_NEON_COLOR
					else
						-- green text
						txtLFR = txtLFR .. GREEN_NEON_COLOR
					end
				else
					-- grey text
					txtLFR = txtLFR .. GREY_COLOR
				end
				txtLFR = txtLFR .. dungeons[v].qtyLooted 
			else
				-- grey text
				txtLFR = txtLFR .. GREY_COLOR .. "0"
			end
		end
		txtLFR = txtLFR .. END_COLOR
	end	

	-- show the Normal Raid.
	if self:GetRaidNormal() then
		txtNormal = self:GetDifficultyKillCount(instanceName, saves, {3, 4, 14, 40})
		txt = txtNormal
	end
	
	-- show the Heroic raid
	if self:GetRaidHeroic() then
		txtHeroic = self:GetDifficultyKillCount(instanceName, saves, {5, 6, 15})
		if txt ~= "" then txt = txt .. ":" end
		txt = txt .. txtHeroic
	end
	
	-- show the Mythic raid
	if self:GetRaidMythic() then
		txtMythic = self:GetDifficultyKillCount(instanceName, saves, {16})
		if txt ~= "" then txt = txt .. ":" end
		txt = txt .. txtMythic
	end

	-- prepend the LFR to txt
	if self:GetRaidLFR() then
		if txt ~= "" then
			txt = txtLFR .. GREEN_NEON_COLOR .. " [" .. txt .. GREEN_NEON_COLOR .. "]"
		else
			txt = txtLFR
		end
	end

	return txt
	--[[
[13:03:01] GetDifficultyInfo 11 Heroic Scenario    scenario true  false false false
[13:03:01] GetDifficultyInfo 12 Normal Scenario    scenario false false false false
[13:03:01] GetDifficultyInfo 20 Event Scenario     scenario false false false false

[13:03:01] GetDifficultyInfo 1  Normal             party    false false false false
[13:03:01] GetDifficultyInfo 2  Heroic             party    true  false false false
[13:03:01] GetDifficultyInfo 8  Challenge Mode     party    true  true  false false
[13:03:01] GetDifficultyInfo 19 Event              party    false false false false

[13:03:01] GetDifficultyInfo 3  10 Player          raid     false false false false  
[13:03:01] GetDifficultyInfo 4  25 Player          raid     false false false false  
[13:03:01] GetDifficultyInfo 5  10 Player (Heroic) raid     true  false false false  
[13:03:01] GetDifficultyInfo 6  25 Player (Heroic) raid     true  false false false  
[13:03:01] GetDifficultyInfo 7  Looking For Raid   raid     false false false false
[13:03:01] GetDifficultyInfo 9  40 Player          raid     false false false false
[13:03:01] GetDifficultyInfo 14 Normal             raid     false false false false
[13:03:01] GetDifficultyInfo 15 Heroic             raid     false false true  false
[13:03:01] GetDifficultyInfo 16 Mythic             raid     true  false false true
[13:03:01] GetDifficultyInfo 17 Looking For Raid   raid     false false false false
[13:03:01] GetDifficultyInfo 18 Event              raid     false false false false
]]

end

function GearGrinder:GetDifficultyKillCount(instanceName, saves, difficulties)

	local found = false;
	local txt, i;
		
	for i = 1, #saves do
		if saves[i].instanceName and saves[i].instanceName == instanceName then 
			if table.contains(difficulties, saves[i].difficultyID) then
				-- we have a match for the instance.
				found = true;
				if saves[i].numBoss then
					if saves[i].numBoss <= saves[i].numKilled then
						txt = RED_NEON_COLOR
					else
						txt = GREEN_NEON_COLOR
					end
					txt = txt .. saves[i].numKilled
				else
					txt = GREEN_NEON_COLOR .. "0"
				end
			end
		end
	end
	
	if not found then
		txt = GREEN_NEON_COLOR .. "0"
	end

	return txt .. END_COLOR

end

function GearGrinder:GetProgressColor(val, maxval, interval)
	m = maxval or math.huge;

	if m == 0 then
		return GREEN_NEON_COLOR;
	elseif val >= m then 
		return RED_NEON_COLOR;
	elseif val >= (m - interval) then 
		return ORANGE_NEON_COLOR;
	elseif val >= (m - 2*interval) then 
		return YELLOW_NEON_COLOR;
	else 
		return GREEN_NEON_COLOR;
	end
	return GREEN_NEON_COLOR;
end

-- Save the data to the database.
function GearGrinder:SaveData(evt)

	local iLvl, iELvl, lvl
	local data

--print("SaveData Event:", evt);

	-- make sure the current values are set.
	if self.currentPlayer == nil then self.currentPlayer = UnitName('player') end;
	if self.currentRealm == nil then self.currentRealm = GetRealmName() end;
	if self.currentClass == nil then _, self.currentClass = UnitClass("player") end;
	if self.currentLocale == nil then self.currentLocale = GetLocale() end;


	self:Debug("Saving Gear Grinder...");
	self:Debug("Current Player " .. self.currentPlayer);
	self:Debug("Current Realm " .. self.currentRealm);
	
	if GG_Storage == nil then
		GG_Storage = {};
	end
	if GG_Storage[self.currentRealm] == nil then
		GG_Storage[self.currentRealm] = {};
	end	
	if GG_Storage[self.currentRealm][self.currentPlayer] == nil then
		GG_Storage[self.currentRealm][self.currentPlayer] = {}
		data = GG_Storage[self.currentRealm][self.currentPlayer]
		local playerClass, englishClass = UnitClass("player")
		data.class = englishClass;
		data.savingTime = 1
	else 
		data = GG_Storage[self.currentRealm][self.currentPlayer]

	end

	data.locale = self.currentLocale;
		
	-- cater for the first time the toon is created.
	if data.savingTime == nil then data.savingTime = 1 end
	
	-- check if the data needs to be reset first.
	local dtPrev = self:GetNextWeeklyReset() - (7 * 24 * 60 * 60);
	if dtPrev >= data.savingTime then self:ResetData(data) end
	
	-- save the time
	data.savingTime = time()
	data.timeDailyReset = self:GetNextDailyReset()

	-- Don't do the Ilvl stuff when leaving the game
	if evt ~= "PLAYER_LEAVING_WORLD" then
		-- Item Level data saving
		lvl = UnitLevel("player")
		iLvl, iELvl = GetAverageItemLevel()
		
		iLvl = floor(iLvl)
		iELvl = floor(iELvl)
		
		if lvl ~= 0 then
			data.lvl = lvl
		end

		if iLvl ~= 0 then
			data.iLvl = iLvl
		end
		
		if iELvl ~= 0 then
			data.iELvl = iELvl
		end
	end

	--self:Print("Saving Data .. " .. evt)

	-- setup the filtered value
	if data.active == nil then data.active = true end
	
	-- Save the rest of the data
	self:SaveCurrencyData(evt, data)
	self:SaveDungeonData(evt, data)
	self:SaveQuestData(evt, data)
	
end

function GearGrinder:SaveCurrencyData(evt, data) 

	if GG_Storage == nil then
		self:SaveData(evt)
	end

	if data == nil then
		if GG_Storage[self.currentRealm][self.currentPlayer] == nil then
			self:SaveData(evt)
		end
		data = GG_Storage[self.currentRealm][self.currentPlayer]

		-- check if the data needs to be reset first.
		local dtPrev = self:GetNextWeeklyReset() - (7 * 24 * 60 * 60);
		if dtPrev >= data.savingTime then self:ResetData(data) end
		
	end

	data.currency = {};
	for a, c in pairs(CURRENCIES) do
		local qty, wkEarn, wkMax, qtyMax
		_, qty, _, wkEarn, wkMax, qtyMax = GetCurrencyInfo(c);
		data.currency[c] = {};
		data.currency[c].qty = qty;
		data.currency[c].qtyMax = qtyMax; --floor(qtyMax/100);
		data.currency[c].wkEarn = wkEarn;
		data.currency[c].wkMax = wkMax;
	end
	
end

function GearGrinder:SaveTradeData(evt, data) 

	if GG_Storage == nil then
		self:SaveData(evt)
	end

	if data == nil then
		if GG_Storage[self.currentRealm][self.currentPlayer] == nil then
			self:SaveData(evt)
		end
		data = GG_Storage[self.currentRealm][self.currentPlayer]
	end
	
	-- ignore if the tradeskill is linked
	if IsTradeSkillLinked() then return nil end
	
	-- save off the tradeskill data
	if data.trade == nil then data.trade = {} end
	
	-- get the professions
	prof1, prof2 = "", ""
	p1, p2 = GetProfessions()
	if p1 then prof1 = GetProfessionInfo(p1) end
	if p2 then prof2 = GetProfessionInfo(p2) end
	
	-- if professions have changed then reset the trade cooldown data
	if data.prof1 ~= nil then
		if data.prof1 ~= prof1 then
			-- reset the trade data, profs have been changed
			data.trade = {}
			data.prof1 = prof1
		end
	else
		data.prof1 = prof1
	end
	
	if data.prof2 ~= nil then
		if data.prof2 ~= prof2 then
			-- reset the trade data, profs have been changed
			data.trade = {}
			data.prof2 = prof2
		end
	else
		data.prof2 = prof2
	end
	
	-- save the profession cooldown data
	for i=1, GetNumTradeSkills() do
		local name = GetTradeSkillInfo(i)
		local cooldown = GetTradeSkillCooldown(i)
		if TRADE_SKILLS[name] ~= nil then 
--print("Trade:" , name, cooldown);
			if cooldown then
				-- time of the reset is fk'ed in wow.  need to overwrite it.
				-- time begin used is the hour of the Daily Reset.  DODGY BLIZZARD!!!!
				local nextReset = self:GetNextDailyReset();--- (24 * 60 * 60);
				data.trade[name] = nextReset
				--data.trade[name] = time() + cooldown  -- save the time it will reset.
			else
				data.trade[name] = 0  -- ability available.
			end
		end
	end

end

function GearGrinder:SaveDungeonData(evt, data)

	--RequestRaidInfo();

	if GG_Storage == nil then
		self:SaveData(evt)
	end

	if data == nil then
		if GG_Storage[self.currentRealm][self.currentPlayer] == nil then
			self:SaveData(evt)
		end
		data = GG_Storage[self.currentRealm][self.currentPlayer]
		
		-- check if the data needs to be reset first.
		local dtPrev = self:GetNextWeeklyReset() - (7 * 24 * 60 * 60);
		if dtPrev >= data.savingTime then self:ResetData(data) end
		
	end

	-----------------
	-- LFR

	-- save off the LFR Raid saves/completions
	data.dungeon = {}
	for i=1, GetNumRFDungeons() do 
		local dungeonID,_,_,_,_,_,_,_,_,expansion = GetRFDungeonInfo(i);
	
		_, numKilled = GetLFGDungeonNumEncounters(dungeonID); 
		_, _, raidCompleted, _ = GetLFGDungeonRewardCapInfo(dungeonID);
		raidAvailable = IsLFGDungeonJoinable(dungeonID);
		raidAvailable = raidAvailable and 1 or 0

		if numKilled ~= 0 or raidCompleted ~= 0 or raidAvailable ~= 0 then
			-- save the values
			if data.dungeon[dungeonID] == nil then data.dungeon[dungeonID] = {} end
			data.dungeon[dungeonID].qtyLooted = numKilled;
			data.dungeon[dungeonID].isComplete = raidCompleted;
			data.dungeon[dungeonID].isAvailable = raidAvailable;
		else 
			data.dungeon[dungeonID] = nil;
		end
	end

	------------
	-- Other Dungeons that need to be saved
	for i, v in pairs(DUNGEONIDS) do
		_, numKilled = GetLFGDungeonNumEncounters(v); 
		_, _, raidCompleted, _ = GetLFGDungeonRewardCapInfo(v);
		raidAvailable = IsLFGDungeonJoinable(v);
		raidAvailable = raidAvailable and 1 or 0

		if numKilled ~= 0 or raidCompleted ~= 0 or raidAvailable ~= false then
			-- save the values
			if data.dungeon[v] == nil then data.dungeon[v] = {} end
			data.dungeon[v].qtyLooted = numKilled;
			data.dungeon[v].isComplete = raidCompleted;
			data.dungeon[v].isAvailable = raidAvailable;
		else 
			data.dungeon[v] = nil;
		end
	end


	-------------
	-- World Bosses

	local numSavedWorldBosses = GetNumSavedWorldBosses();
	data.worldboss = {};
	for i = 1, numSavedWorldBosses do
		local instanceName, instanceID, instanceReset = GetSavedWorldBossInfo(i);
		data.worldboss[instanceName] = {};
		data.worldboss[instanceName].name = instanceName;
		data.worldboss[instanceName].ID = instanceID;
		data.worldboss[instanceName].resetTime = time()+instanceReset;
	end

	------------
	-- Raid Dungeon Saves

	data.saves = {};
	local newIndex = 1;
	for i = 1, GetNumSavedInstances() do
		local instanceName, instanceID, instanceReset, instanceDifficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName, maxBosses, defeatedBosses = GetSavedInstanceInfo(i);
		
		-- we have a match
		if locked then
			data.saves[newIndex] = {};
			data.saves[newIndex].instanceName = instanceName;
			data.saves[newIndex].resetTime = time() + instanceReset;
			data.saves[newIndex].ID = instanceID;
			data.saves[newIndex].difficultyID = instanceDifficulty;
			data.saves[newIndex].instanceID = instanceIDMostSig;
			data.saves[newIndex].maxPlayers = maxPlayers;
			data.saves[newIndex].difficultyName = difficultyName;
			data.saves[newIndex].numBoss = maxBosses;
			data.saves[newIndex].numKilled = defeatedBosses;

			local hlink = GetSavedInstanceChatLink(i);
			if hlink then
				local bmask, z;
				bmask = hlink;
				-- find the 4th :
				for z=1, 4 do
					bmask = string.sub(bmask, string.find(bmask, ":")+1);
				end
				-- extract up to the next |
				bmask = string.sub(bmask, 1, string.find(bmask, "|")-1);
			
				data.saves[newIndex].bitmask = tonumber(bmask);
			end
			newIndex = newIndex + 1;
		end
	end


end

function GearGrinder:SaveFarmData(evt, action)  	-- valid actions = Harvest, Sow, Sow4
	local data, diff
	
	-- verify the storage.
	if GG_Storage == nil then
		self:SaveData(evt)
	end
	if GG_Storage[self.currentRealm][self.currentPlayer] == nil then
		self:SaveData(evt)
	end
	data = GG_Storage[self.currentRealm][self.currentPlayer]

	self:UpdateFarmSize(data)
	
	-- initialise if needed
	if data.farmTime == nil then data.farmTime = time() end
	if data.farmSow == nil then data.farmSow = 0 end
	if data.farmHarvest == nil then data.farmHarvest = 0 end
	
	-- calculate the previous reset time
	local dtDailyPrev = self:GetNextDailyReset() - (24 * 60 * 60);

	-- check reset time.
	-- if farm has matured then update harvest qty
	if data.farmTime <= dtDailyPrev then
		data.farmHarvest = data.farmHarvest + data.farmSow
		if data.farmHarvest > data.farmSize then data.farmHarvest = data.farmSize end  -- Test the Harvest has not exceeded the farm size
		
		data.farmSow = 0
	end
	
	-- save the time the farm was last processed
	data.farmTime = time()
	
	-- process the action but don't exceed the min/max
	if action == "Sow" or action == "Sow4" then 
		if action == "Sow4" then diff = 4 else diff = 1 end
		data.farmSow = data.farmSow + diff
	end
	if action == "Harvest" then 
		data.farmHarvest = data.farmHarvest - 1
	end
	
	-- check totals and adjust if needed
	if data.farmSow < 0 then data.farmSow = 0 end
	if data.farmSow > data.farmSize then data.farmSow = data.farmSize end
	
	if data.farmHarvest < 0 then data.farmHarvest = 0 end
	if data.farmHarvest > data.farmSize then data.farmHarvest = data.farmSize end

end

function GearGrinder:SaveQuestData(evt, data)

	local t
	
	if GG_Storage == nil then
		self:SaveData(evt)
	end

	if data == nil then
		if GG_Storage[self.currentRealm][self.currentPlayer] == nil then
			self:SaveData(evt)
		end
		data = GG_Storage[self.currentRealm][self.currentPlayer]
		
		-- check if the data needs to be reset first.
		local dtPrev = self:GetNextWeeklyReset() - (7 * 24 * 60 * 60);
		if dtPrev >= data.savingTime then self:ResetData(data) end
		
	end
	
	-- get all quests completed
	t = GetQuestsCompleted()
	
	-- save all quests
	--data.quest = t
	
	-- flush all quests
	data.quest = {}

	for i, v in pairs(QUESTS) do
		data.quest[v] = t[v]
	end
	
	for i, v in pairs(WORLD_BOSSES) do
		if v.quest and v.quest > 0 then
			data.quest[v.quest] = t[v.quest]
		end
	end

	self:UpdateFarmSize(data)
	
end

function GearGrinder:SaveGarrisonData(evt, data)

--print("SaveGarrisonData Event:", evt);
	
	if GG_Storage == nil then
		self:SaveData(evt)
	end

	if data == nil then
		if GG_Storage[self.currentRealm][self.currentPlayer] == nil then
			self:SaveData(evt)
		end
		data = GG_Storage[self.currentRealm][self.currentPlayer]
		
		-- check if the data needs to be reset first.
		local dtPrev = self:GetNextWeeklyReset() - (7 * 24 * 60 * 60);
		if dtPrev >= data.savingTime then self:ResetData(data) end
		
	end

	-- heaps to save off
	-- buildings
	-- shipments
	-- followers
	-- missions
	
	-- refresh the data to the client  need to respond to the event.. not here.
	--C_Garrison.RequestShipmentInfo();
	--C_Garrison.RequestLandingPageShipmentInfo();

	if data.garrison == nil then data.garrison = {} end
	
	-- get a reference to the garrison data
	gar = data.garrison;

	-- save the time the garrison data was saved
	gar.saveTime = time();

	-- save the garrison details
	gar.level = C_Garrison.GetGarrisonInfo();

	local garbuild, garship, garfollow, garmission;
	
	-- flush the saved data.
	gar.buildings = {}; 
	gar.shipments = {};
	gar.followers = {};
	gar.plots = nil;
	gar.missions = {};

	garbuild = gar.buildings;
	garship = gar.shipments;
	garfollow = gar.followers;
	garmission = gar.missions;

	-- save the Buildings on the Plots
	local p = C_Garrison.GetBuildings();
	gar.numPlots = #p; -- number of plots
	for i = 1, #p do
		local id = p[i].plotID;
		if (id) then
			--buildingID, name, texPrefix, icon, description, rank, currencyID, currencyQty, goldQty, buildTime, needsPlan, isPrebuilt, possSpecs, upgrades, canUpgrade, isMaxLevel, hasFollowerSlot, knownSpecs, currSpec, specCooldown, isBuilding, startTime, buildDuration, timeLeftStr, canActivate = C_Garrison.GetOwnedBuildingInfo(id);
			local buildingID, name, _, _, _, rank, _, _, _, _, needsPlan, _, _, _, _, _, hasFollowerSlot, _, _, _, isBuilding, startTime, buildDuration = C_Garrison.GetOwnedBuildingInfo(id);
			if (buildingID) then
				garbuild[buildingID] = {};
				garbuild[buildingID].plotID = id;
				garbuild[buildingID].buildingID = buildingID;
				garbuild[buildingID].name = name;
				garbuild[buildingID].rank = rank;
				garbuild[buildingID].hasFollowerSlot = hasFollowerSlot;
				garbuild[buildingID].isBuilding = isBuilding;
				garbuild[buildingID].startTime = startTime;
				garbuild[buildingID].buildDuration = buildDuration;

				local _, _, _, _, followerID = C_Garrison.GetFollowerInfoForBuilding(id);
				if (followerID) then
					garbuild[buildingID].followerID = followerID;
			
				end

				-- save the Shipments
				local n, _, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, _, itemName, _, _, itemID = C_Garrison.GetLandingPageShipmentInfo(buildingID);
				if (n) then
					garship[n] = {};
					garship[n].name = n;
					garship[n].buildingID = buildingID;
					garship[n].shipmentCapacity = shipmentCapacity;
					garship[n].shipmentsReady = shipmentsReady;
					garship[n].shipmentsTotal = shipmentsTotal;
					garship[n].creationTime = creationTime;
					garship[n].duration = duration;
					garship[n].itemName = itemName;
					garship[n].itemID = itemID;
				end
				--local shipmentsAvailable = shipmentCapacity;
				--if(shipmentsTotal) then
				--	shipmentsAvailable = shipmentCapacity - shipmentsTotal;
				--end
			end
		end
	end

	-- save the Followers
	local f = C_Garrison.GetFollowers();
	for i = 1, #f do
		local id = f[i].followerID
		if (f[i].isCollected) then
			--local vals = {C_Garrison.GetFollowerInfo(followers[i].followerID)};
			garfollow[id] = {};
			garfollow[id].followerID = id;
			garfollow[id].level = f[i].level;
			garfollow[id].garrFollowerID = f[i].garrFollowerID;
			garfollow[id].quality = f[i].quality;
			garfollow[id].levelXP = f[i].levelXP;
		end
	end

	-- save the Missions
	local m = C_Garrison.GetInProgressMissions();
	for i = 1, #m do
		local id = m[i].missionID
		garmission[id] = {};
		garmission[id].missionID = id;
		garmission[id].numFollowers = m[i].numFollowers;
		garmission[id].duration = m[i].durationSeconds;
		garmission[id].timeLeft = m[i].timeLeft;
		garmission[id].startTime = gar.saveTime + self:TimeToSeconds(m[i].timeLeft) - m[i].durationSeconds;  -- this is crap.. there is no start time in seconds.

		-- link the followers to the mission
		for j = 1, #m[i].followers do
			local folID = m[i].followers[j];
			garfollow[folID].missionID = id;
		end
	end

	-- engineer a mission record that will show up as 'to be collected'
	local m = C_Garrison.GetCompleteMissions();
	for i = 1, #m do
		local id = m[i].missionID
		garmission[id] = {};
		garmission[id].missionID = id;
		garmission[id].numFollowers = m[i].numFollowers;
		garmission[id].duration = 1;
		garmission[id].timeLeft = "0 sec";
		garmission[id].startTime = gar.saveTime - 10;

		-- link the followers to the mission
		for j = 1, #m[i].followers do
			local folID = m[i].followers[j];
			garfollow[folID].missionID = id;
		end
	end

end

function GearGrinder:SaveGarrisonSpell(spellID)

	local zone = { 
		[947] = 1, [971] = 1, -- Alliance
		[976] = 1, [980] = 1, [981] = 1, [982] = 1, -- Horde
	}

--print("SaveGarrisonSpell", spellID, GetCurrentMapAreaID());

	-- ignore the spell if not at the garrison.
	if zone[GetCurrentMapAreaID()] == nil then return nil end;

	if GG_Storage == nil then
		self:SaveData(evt)
	end

	if data == nil then
		if GG_Storage[self.currentRealm][self.currentPlayer] == nil then
			self:SaveData(evt)
		end
		data = GG_Storage[self.currentRealm][self.currentPlayer]
		
		-- check if the data needs to be reset first.
		local dtPrev = self:GetNextWeeklyReset() - (7 * 24 * 60 * 60);
		if dtPrev >= data.savingTime then self:ResetData(data) end
		
	end

	if data.garrison == nil then self:SaveGarrisonData("SPELL", data) end
	
	-- get a reference to the garrison data
	gar = data.garrison;

	-- check if spells saved
	if gar.spell == nil then gar.spell = {} end;

	-- save the activity spell time
	gar.spell[spellID] = time();

end

function GearGrinder:TimeToSeconds(timeStr)

	if timeStr == nil then return 0 end;
	
	local t = split(timeStr, " ");  -- space separated
	if floor(#t/2) ~= #t/2 then return 0 end; -- must have even number of elements
	
	local secval = 0;
	for i = 1, #t - 1, 2 do
		if i == #t - 1 then t[i] = tonumber(t[i])+1 end;  -- over state by one to be sure.

		if t[i+1] == "days" or t[i+1] == "day" then  -- days
			secval = secval + tonumber(t[i]) * 24 * 60 * 60;
		elseif t[i+1] == "hr" or t[i+1] == "hrs" then	-- hr
			secval = secval + tonumber(t[i]) * 60 * 60;
		elseif t[i+1] == "min" or t[i+1] == "Min" then	-- min
			secval = secval + tonumber(t[i]) * 60;
		elseif t[i+1] == "sec" or t[i+1] == "Sec" then	-- sec
			secval = secval + tonumber(t[i]);
		else
			--unknown time interval
			--ignore.
		end
	end

	return secval;

end

function GearGrinder:ResetData(data)

	-- data is mandatory.  must be called from one of the Save Data functions
	if data == nil then return end

	if data.active == nil then data.active = true end	
		
	-- reset the LFR data
	data.dungeon = {}

	-- reset the quest tracking
	data.quest = {}
	
	-- reset the saves
	data.saves = {}
	
	-- reset world boss
	data.worldboss = {}

	-- reset garrison
	data.garrison = {}

	-- dont' reset trade data.  it get's reset as needed.
	--data.trade = {}
	
	-- initialise the farm values
	if data.farmSize == nil then data.farmSize = 0 end
	if data.farmTime == nil then data.farmTime = 0 end
	if data.farmHarvest == nil then data.farmHarvest = 0 end
	if data.farmSow == nil then data.farmSow = 0 end
	
end

function GearGrinder:SaveFakeQuestKill(q)

	local data = GG_Storage[self.currentRealm][self.currentPlayer]
	if data.boss == nil then data.boss = {} end
	data.boss[q] = true

end

function GearGrinder:UpdateFarmSize(data)
	
	-- will always be called with a value for the parameter
	if data == nil then return end
	
	-- setup the farm size 
	data.farmSize = 0
	if data.quest[QUESTS.farm4] and data.quest[QUESTS.farm4] == true then data.farmSize = 4 end
	if data.quest[QUESTS.farm8] and data.quest[QUESTS.farm8] == true then data.farmSize = 8 end
	if data.quest[QUESTS.farm12] and data.quest[QUESTS.farm12] == true then data.farmSize = 12 end
	if data.quest[QUESTS.farm16] and data.quest[QUESTS.farm16] == true then data.farmSize = 16 end
	
	-- set the farm data to 0 so the tooltip works with the reset code.
	if data.farmTime == nil then data.farmTime = 0 end
	if data.farmHarvest == nil then data.farmHarvest = 0 end
	if data.farmSow == nil then data.farmSow = 0 end
	
end

-- Make sure the database is the latest version
function GearGrinder:UpdateSettings()
    
    if self.db.global.version == self.versionMajor then
        -- Same version
		return
    end
    
    -- Update version information
	if self.db.global.version == 1 then
		-- upgrade from 1 to 2
		
		self.db.global.version = 2;

		for r, toons in pairs(GG_Storage) do

			GG_Storage[r]["__orderedIndex"] = nil;

			for t, alt in pairs(GG_Storage[r]) do

				if alt.iLvl == nil then alt.iLvl = 0 end
				if alt.iELvl == nil then alt.iELvl = 0 end
				if alt.active == nil then alt.active = true end


				-- convert to the new format.
				alt.currency = {};


				alt.currency[CURRENCIES.APEXIS] = {};
				alt.currency[CURRENCIES.APEXIS].qty = alt.qtyApexis;

				alt.currency[CURRENCIES.GARRISON] = {};
				alt.currency[CURRENCIES.GARRISON].qty = alt.qtyGarRes;

				alt.currency[CURRENCIES.CONQUEST] = {};
				alt.currency[CURRENCIES.CONQUEST].qty = alt.qtyCP;
				alt.currency[CURRENCIES.CONQUEST].qtyMax = alt.qtyMaxCP;
				alt.currency[CURRENCIES.CONQUEST].wkEarn = alt.periodEarnCP;
				alt.currency[CURRENCIES.CONQUEST].wkMax = alt.periodMaxCP;

				alt.currency[CURRENCIES.HONOR] = {};
				alt.currency[CURRENCIES.HONOR].qty = alt.qtyHP;
				alt.currency[CURRENCIES.HONOR].qtyMax = alt.qtyMaxHP;
				alt.currency[CURRENCIES.HONOR].wkEarn = alt.periodEarnHP;

				alt.currency[CURRENCIES.ELDER] = {};
				alt.currency[CURRENCIES.ELDER].qty = alt.qtyECharm;

				alt.currency[CURRENCIES.LESSER] = {};
				alt.currency[CURRENCIES.LESSER].qty = alt.qtyLCharm;

				alt.currency[CURRENCIES.MOGU] = {};
				alt.currency[CURRENCIES.MOGU].qty = alt.qtyMCharm;

				alt.currency[CURRENCIES.TIMELESS] = {};
				alt.currency[CURRENCIES.TIMELESS].qty = alt.qtyTimeless;

				alt.currency[CURRENCIES.WARSEAL] = {};
				alt.currency[CURRENCIES.WARSEAL].qty = alt.qtyWCharm;

				alt.currency[CURRENCIES.FATE] = {};
				alt.currency[CURRENCIES.FATE].qty = alt.qtyFCharm;

				-- Erase old values
				alt.qtyVP = nil
				alt.qtyJP = nil
				alt.qtyMaxVP = nil
				alt.qtyMaxJP = nil
				alt.periodEarnVP = nil
				alt.periodMaxVP = nil
				alt.periodEarnJP = nil
				alt.periodEarnCP = nil
				alt.periodEarnHP = nil
				alt.qtyCP = nil
				alt.qtyHP = nil
				alt.qtyApexis = nil
				alt.qtyGarRes = nil
				alt.qtyCP = nil
				alt.qtyMaxCP = nil
				alt.periodEarnCP = nil
				alt.periodMaxCP = nil
				alt.qtyHP = nil
				alt.periodEarnHP = nil
				alt.qtyMaxHP = nil
				alt.qtyECharm = nil
				alt.qtyLCharm = nil
				alt.qtyMCharm = nil
				alt.qtyTimeless = nil
				alt.qtyWCharm = nil
				alt.qtyFCharm = nil

				alt.boss = nil
				alt.boss1, alt.boss2, alt.boss3, alt.boss4 = nil,nil,nil,nil

				alt.worldboss = {}
				--alt.dungeon = {}  -- dungeon format has not changed
				--alt.quest = {}    -- quest format has not changed but less quests are stored.
				alt.saves = {}
				alt.garrison = {}

			end
		end
	end
	
end

-- Purge the Database
function GearGrinder:PurgeDB()

	GG_Storage = nil;
	
	self:SaveData("PURGEDB");

end

--[[

    Setters, Getter and Togglers

]]

-- Set
function GearGrinder:SetShowCombat(v) self.db.global.combat = v; end

function GearGrinder:SetToonRealm(v) self.db.global.ToonRealm = v; end
function GearGrinder:SetToonRealmGroup(v) self.db.global.ToonRealmGroup = v; end
function GearGrinder:SetToonShowRealm(v) self.db.global.ToonShowRealm = v; end
function GearGrinder:SetToonCharms(v) self.db.global.ToonCharms = v; end
function GearGrinder:SetToonActivity(v) self.db.global.ToonActivity = v; end
function GearGrinder:SetToonGarrison(v) self.db.global.ToonGarrison = v; end
function GearGrinder:SetToonLevel(v) self.db.global.ToonLevel = v; end
function GearGrinder:SetTooniLevel(v) self.db.global.TooniLevel = v; end
function GearGrinder:SetTooniELevel(v) self.db.global.TooniELevel = v; end
function GearGrinder:SetToonFarm(v) self.db.global.ToonFarm = v; end
function GearGrinder:SetToonProfCD(v) self.db.global.ToonProfCD = v; end
function GearGrinder:SetToonHP(v) self.db.global.ToonHP = v; end
function GearGrinder:SetToonCP(v) self.db.global.ToonCP = v; end
function GearGrinder:SetToonCPCap(v) self.db.global.ToonCPCap =v; end
function GearGrinder:SetToonTimeless(v) self.db.global.ToonTimeless = v; end
function GearGrinder:SetToonApexis(v) self.db.global.ToonApexis = v; end
function GearGrinder:SetToonGarRes(v) self.db.global.ToonGarRes = v; end

function GearGrinder:SetActivityC(v) self.db.global.ActivityC = v; end
function GearGrinder:SetActivityD(v) self.db.global.ActivityD = v; end
function GearGrinder:SetActivityH(v) self.db.global.ActivityH = v; end
function GearGrinder:SetActivityHS(v) self.db.global.ActivityHS = v; end
function GearGrinder:SetActivityS(v) self.db.global.ActivityS = v; end
function GearGrinder:SetActivityR(v) self.db.global.ActivityR = v; end

function GearGrinder:SetSortOrder(v) 
	if v < 1 or v == 4 or v > 5 then 
		self.db.global.sortOrder = 5
	else
		self.db.global.sortOrder = v
	end
end

function GearGrinder:SetGarrison(v) self.db.global.gar = v; end
function GearGrinder:SetGarrisonLevel(v) self.db.global.garLevel = v; end
function GearGrinder:SetGarrisonResource(v) self.db.global.garResource = v; end
function GearGrinder:SetGarrisonMission(v) self.db.global.garMission = v; end
function GearGrinder:SetGarrisonShipment(v) self.db.global.garShipment = v; end
function GearGrinder:SetGarrisonActivity(v) self.db.global.garActivity = v; end
function GearGrinder:SetGarrisonFollower(v) self.db.global.garFollower = v; end
function GearGrinder:SetGarrisonBuilding(v) self.db.global.garBuilding = v; end
function GearGrinder:SetGarrisonActivityMine(v) self.db.global.garActivityMine = v; end
function GearGrinder:SetGarrisonActivityHerb(v) self.db.global.garActivityHerb = v; end

function GearGrinder:SetRaid(v) self.db.global.raid = v; end
function GearGrinder:SetRaidLFR(v) self.db.global.raidLFR = v; end
function GearGrinder:SetRaidNormal(v) self.db.global.raidNormal = v; end
function GearGrinder:SetRaidHeroic(v) self.db.global.raidHeroic = v; end
function GearGrinder:SetRaidMythic(v) self.db.global.raidMythic = v; end

function GearGrinder:SetCharmLesser(v) self.db.global.charmLesser = v; end
function GearGrinder:SetCharmElder(v) self.db.global.charmElder = v; end
function GearGrinder:SetCharmMogu(v) self.db.global.charmMogu = v; end
function GearGrinder:SetCharmWarSeal(v) self.db.global.charmWarSeal = v; end
function GearGrinder:SetCharmFate(v) self.db.global.charmFate = v; end

function GearGrinder:SetRaidMV(v) self.db.global.RaidMV = v; end
function GearGrinder:SetRaidHoF(v) self.db.global.RaidHoF = v; end
function GearGrinder:SetRaidToES(v) self.db.global.RaidToES = v; end
function GearGrinder:SetRaidToT(v) self.db.global.RaidToT = v; end
function GearGrinder:SetRaidSoO(v) self.db.global.RaidSoO = v; end
function GearGrinder:SetRaidHM(v) self.db.global.RaidHM = v; end
function GearGrinder:SetRaidBRF(v) self.db.global.RaidBRF = v; end

function GearGrinder:SetWorldBoss(v) self.db.global.worldBoss = v; end
function GearGrinder:SetBossSha(v) self.db.global.BossSha = v; end
function GearGrinder:SetBossGalleon(v) self.db.global.BossGalleon = v; end
function GearGrinder:SetBossNalak(v) self.db.global.BossNalak = v; end
function GearGrinder:SetBossOondasta(v) self.db.global.BossOondasta = v; end
function GearGrinder:SetBossCelestial(v) self.db.global.BossCelestial = v; end
function GearGrinder:SetBossOrdos(v) self.db.global.BossOrdos = v; end
function GearGrinder:SetBossDrov(v) self.db.global.BossDrov = v; end
function GearGrinder:SetBossTarina(v) self.db.global.BossTarina = v; end
function GearGrinder:SetBossRukhmar(v) self.db.global.BossRukhmar = v; end

function GearGrinder:SetProfAlc(v) self.db.global.ProfAlc = v; end
function GearGrinder:SetProfBS(v) self.db.global.ProfBS = v; end
function GearGrinder:SetProfBS2(v) self.db.global.ProfBS2 = v; end
function GearGrinder:SetProfEnch(v) self.db.global.ProfEnch = v; end
function GearGrinder:SetProfTailor(v) self.db.global.ProfTailor = v; end
function GearGrinder:SetProfTailor2(v) self.db.global.ProfTailor2 = v; end
function GearGrinder:SetProfScribe(v) self.db.global.ProfScribe = v; end
function GearGrinder:SetProfJCGem(v) self.db.global.ProfJCGem = v; end
function GearGrinder:SetProfJCHeart(v) self.db.global.ProfJCHeart = v; end
function GearGrinder:SetProfLW(v) self.db.global.ProfLW = v; end
function GearGrinder:SetProfLW2(v) self.db.global.ProfLW2 = v; end
function GearGrinder:SetProfEng(v) self.db.global.ProfEng = v; end

function GearGrinder:SetProfWoDAlc1(v) self.db.global.ProfWoDAlc1 = v; end
function GearGrinder:SetProfWoDAlc2(v) self.db.global.ProfWoDAlc2 = v; end
function GearGrinder:SetProfWoDBS1(v) self.db.global.ProfWoDBS1 = v; end
function GearGrinder:SetProfWoDBS2(v) self.db.global.ProfWoDBS2 = v; end
function GearGrinder:SetProfWoDEnc1(v) self.db.global.ProfWoDEnc1 = v; end
function GearGrinder:SetProfWoDEnc2(v) self.db.global.ProfWoDEnc2 = v; end
function GearGrinder:SetProfWoDTailor1(v) self.db.global.ProfWoDTailor1 = v; end
function GearGrinder:SetProfWoDTailor2(v) self.db.global.ProfWoDTailor2 = v; end
function GearGrinder:SetProfWoDScribe1(v) self.db.global.ProfWoDScribe1 = v; end
function GearGrinder:SetProfWoDScribe2(v) self.db.global.ProfWoDScribe2 = v; end
function GearGrinder:SetProfWoDJC1(v) self.db.global.ProfWoDJC1 = v; end
function GearGrinder:SetProfWoDJC2(v) self.db.global.ProfWoDJC2 = v; end
function GearGrinder:SetProfWoDLW1(v) self.db.global.ProfWoDLW1 = v; end
function GearGrinder:SetProfWoDLW2(v) self.db.global.ProfWoDLW2 = v; end
function GearGrinder:SetProfWoDEng1(v) self.db.global.ProfWoDEng1 = v; end
function GearGrinder:SetProfWoDEng2(v) self.db.global.ProfWoDEng2 = v; end

function GearGrinder:SetTTScale(v) self.db.global.ttScale = v; end
function GearGrinder:SetAltLine(v) self.db.global.Background.AltLine = v; end
function GearGrinder:SetFiltering(v) self.db.global.filtering = v; end
function GearGrinder:SetBgGeneric(i, v) self.db.global.Background[ i[#i] ] = v end
function GearGrinder:SetLabel(v) self.db.global.showLabel = v; self:UpdateLDB(true); end

function GearGrinder:SetLDBlabel(v) self.db.global.ldbLabel = v; self:UpdateLDB(true); end
function GearGrinder:SetLDBTextColor(v) self.db.global.ldbTextColor = v; self:UpdateLDB(true); end
function GearGrinder:SetLDBDisplayLock(v) self.db.global.ldbDisplayLock = v; end
function GearGrinder:SetLDBDisplayLFR(v) self.db.global.ldbDisplayLFR = v; self:UpdateLDB(true); end
function GearGrinder:SetLDBDisplayRaid(v) self.db.global.ldbDisplayRaid = v; self:UpdateLDB(true); end
function GearGrinder:SetLDBDisplayRoll(v) self.db.global.ldbDisplayRoll = v; self:UpdateLDB(true); end
function GearGrinder:SetLDBDisplayBoss(v) self.db.global.ldbDisplayBoss = v; self:UpdateLDB(true); end

-- Get
function GearGrinder:GetMinimap() return not self.db.global.minimap.hide; end
function GearGrinder:GetDebug() return self.db.char.debug; end
function GearGrinder:GetShowCombat() return self.db.global.combat; end
function GearGrinder:GetSortOrder() 
	if self.db.global.sortOrder < 1 or self.db.global.sortOrder == 4 or self.db.global.sortOrder > 5 then 
		self.db.global.sortOrder = 5
	end
	return self.db.global.sortOrder
end
function GearGrinder:GetBgGeneric(i) return self.db.global.Background[ i[#i] ] end
function GearGrinder:GetBGTile() return self.db.global.Background.Tile end
function GearGrinder:GetTTScale() return self.db.global.ttScale end
function GearGrinder:GetAltLine() return self.db.global.Background.AltLine end
function GearGrinder:GetFiltering() return self.db.global.filtering end

function GearGrinder:GetLabel() return self.db.global.showLabel; end
function GearGrinder:GetLDB() return self.db.global.ldbText; end
function GearGrinder:GetLDBTextColor() return self.db.global.ldbTextColor; end
function GearGrinder:GetLDBlabel() return self.db.global.ldbLabel; end
function GearGrinder:GetLDBDisplayLFR() return self.db.global.ldbDisplayLFR end
function GearGrinder:GetLDBDisplayRaid() return self.db.global.ldbDisplayRaid end
function GearGrinder:GetLDBDisplayRoll() return self.db.global.ldbDisplayRoll end
function GearGrinder:GetLDBDisplayBoss() return self.db.global.ldbDisplayBoss end

function GearGrinder:GetToonRealm() return self.db.global.ToonRealm; end
function GearGrinder:GetToonRealmGroup() return self.db.global.ToonRealmGroup; end
function GearGrinder:GetToonShowRealm() return self.db.global.ToonShowRealm; end
function GearGrinder:GetToonCharms() return self.db.global.ToonCharms; end
function GearGrinder:GetToonActivity() return self.db.global.ToonActivity; end
function GearGrinder:GetToonLevel() return self.db.global.ToonLevel; end
function GearGrinder:GetTooniLevel() return self.db.global.TooniLevel; end
function GearGrinder:GetTooniELevel() return self.db.global.TooniELevel; end
function GearGrinder:GetToonFarm() return self.db.global.ToonFarm end
function GearGrinder:GetToonProfCD() return self.db.global.ToonProfCD end
function GearGrinder:GetToonHP() return self.db.global.ToonHP end
function GearGrinder:GetToonCP() return self.db.global.ToonCP end
function GearGrinder:GetToonCPCap() return self.db.global.ToonCPCap end
function GearGrinder:GetToonTimeless() return self.db.global.ToonTimeless end
function GearGrinder:GetToonApexis() return self.db.global.ToonApexis end
function GearGrinder:GetToonGarRes() return self.db.global.ToonGarRes end

function GearGrinder:GetActivityC() return self.db.global.ActivityC; end
function GearGrinder:GetActivityD() return self.db.global.ActivityD; end
function GearGrinder:GetActivityH() return self.db.global.ActivityH; end
function GearGrinder:GetActivityHS() return self.db.global.ActivityHS; end
function GearGrinder:GetActivityS() return self.db.global.ActivityS; end
function GearGrinder:GetActivityR() return self.db.global.ActivityR; end

function GearGrinder:GetGarrison() return self.db.global.gar end
function GearGrinder:GetGarrisonLevel() return self.db.global.garLevel end
function GearGrinder:GetGarrisonResource() return self.db.global.garResource end
function GearGrinder:GetGarrisonMission() return self.db.global.garMission end
function GearGrinder:GetGarrisonShipment() return self.db.global.garShipment end
function GearGrinder:GetGarrisonActivity() return self.db.global.garActivity end
function GearGrinder:GetGarrisonFollower() return self.db.global.garFollower end
function GearGrinder:GetGarrisonBuilding() return self.db.global.garBuilding end
function GearGrinder:GetGarrisonActivityMine() return self.db.global.garActivityMine end
function GearGrinder:GetGarrisonActivityHerb() return self.db.global.garActivityHerb end

function GearGrinder:GetRaid() return self.db.global.raid end
function GearGrinder:GetRaidLFR() return self.db.global.raidLFR end
function GearGrinder:GetRaidNormal() return self.db.global.raidNormal end
function GearGrinder:GetRaidHeroic() return self.db.global.raidHeroic end
function GearGrinder:GetRaidMythic() return self.db.global.raidMythic end

function GearGrinder:GetCharmLesser() return self.db.global.charmLesser end
function GearGrinder:GetCharmElder() return self.db.global.charmElder end
function GearGrinder:GetCharmMogu() return self.db.global.charmMogu end
function GearGrinder:GetCharmWarSeal() return self.db.global.charmWarSeal end
function GearGrinder:GetCharmFate() return self.db.global.charmFate end

function GearGrinder:GetRaidMV() return self.db.global.RaidMV end
function GearGrinder:GetRaidHoF() return self.db.global.RaidHoF end
function GearGrinder:GetRaidToES() return self.db.global.RaidToES end
function GearGrinder:GetRaidToT() return self.db.global.RaidToT end
function GearGrinder:GetRaidSoO() return self.db.global.RaidSoO end
function GearGrinder:GetRaidHM() return self.db.global.RaidHM end
function GearGrinder:GetRaidBRF() return self.db.global.RaidBRF end

function GearGrinder:GetWorldBoss() return self.db.global.worldBoss; end
function GearGrinder:GetBossSha() return self.db.global.BossSha end
function GearGrinder:GetBossGalleon() return self.db.global.BossGalleon end
function GearGrinder:GetBossNalak() return self.db.global.BossNalak end
function GearGrinder:GetBossOondasta() return self.db.global.BossOondasta end
function GearGrinder:GetBossCelestial() return self.db.global.BossCelestial end
function GearGrinder:GetBossOrdos() return self.db.global.BossOrdos end
function GearGrinder:GetBossDrov() return self.db.global.BossDrov end
function GearGrinder:GetBossTarina() return self.db.global.BossTarina end
function GearGrinder:GetBossRukhmar() return self.db.global.BossRukhmar end

function GearGrinder:GetProfAlc() return self.db.global.ProfAlc end
function GearGrinder:GetProfBS() return self.db.global.ProfBS end
function GearGrinder:GetProfBS2() return self.db.global.ProfBS2 end
function GearGrinder:GetProfTailor() return self.db.global.ProfTailor end
function GearGrinder:GetProfTailor2() return self.db.global.ProfTailor2 end
function GearGrinder:GetProfEnch() return self.db.global.ProfEnch end
function GearGrinder:GetProfScribe() return self.db.global.ProfScribe end
function GearGrinder:GetProfJCGem() return self.db.global.ProfJCGem end
function GearGrinder:GetProfJCHeart() return self.db.global.ProfJCHeart end
function GearGrinder:GetProfLW() return self.db.global.ProfLW end
function GearGrinder:GetProfLW2() return self.db.global.ProfLW2 end
function GearGrinder:GetProfEng() return self.db.global.ProfEng end

function GearGrinder:GetProfWoDAlc1() return self.db.global.ProfWoDAlc1 end
function GearGrinder:GetProfWoDAlc2() return self.db.global.ProfWoDAlc2 end
function GearGrinder:GetProfWoDBS1() return self.db.global.ProfWoDBS1 end
function GearGrinder:GetProfWoDBS2() return self.db.global.ProfWoDBS2 end
function GearGrinder:GetProfWoDEnc1() return self.db.global.ProfWoDEnc1 end
function GearGrinder:GetProfWoDEnc2() return self.db.global.ProfWoDEnc2 end
function GearGrinder:GetProfWoDTailor1() return self.db.global.ProfWoDTailor1 end
function GearGrinder:GetProfWoDTailor2() return self.db.global.ProfWoDTailor2 end
function GearGrinder:GetProfWoDScribe1() return self.db.global.ProfWoDScribe1 end
function GearGrinder:GetProfWoDScribe2() return self.db.global.ProfWoDScribe2 end
function GearGrinder:GetProfWoDJC1() return self.db.global.ProfWoDJC1 end
function GearGrinder:GetProfWoDJC2() return self.db.global.ProfWoDJC2 end
function GearGrinder:GetProfWoDLW1() return self.db.global.ProfWoDLW1 end
function GearGrinder:GetProfWoDLW2() return self.db.global.ProfWoDLW2 end
function GearGrinder:GetProfWoDEng1() return self.db.global.ProfWoDEng1 end
function GearGrinder:GetProfWoDEng2() return self.db.global.ProfWoDEng2 end

function GearGrinder:GetXpac() 
	return GetExpansionLevel() --+1  -- For testing add one to the value
end

function GearGrinder:ToggleToonFilter() self:SetToonFilter(not self:GetToonFilter()); end

-- Advanced Gets
function GearGrinder:GetBGColor(i)
	local t = self.db.global.Background.Color
	return t.r, t.g, t.b, t.a
end

function GearGrinder:GetBGBorderColor(i)
	local x = self.db.global.Background.BorderColor
	return x.r, x.g, x.b, x.a
end

function GearGrinder:GetAltLineColor(i)
	local t = self.db.global.Background.AltLineColor
	return t.r, t.g, t.b, t.a
end

function GearGrinder:GetRemainingTimeText(seconds)
	local days = floor(seconds / 86400);
	seconds = seconds - days * 86400;
	local hours = floor(seconds / 3600);
	seconds = seconds - hours * 3600;
	local minutes = floor(seconds / 60);
	seconds = seconds - minutes * 60;
	local TIME_COLOR = "";
	local TIME_TEXT = "";
	local timeStr = "";		-- one space just to pad slightly vs being too close to raid/instance name string.
	
	-- compact view's colors.
	-- moved "Reset in" text so that it's now above lockout time.
	TIME_COLOR = WHITE_BRIGHT_COLOR ;
	TIME_TEXT = WHITE_BRIGHT_COLOR ;
	
	if days > 0 then
		timeStr = timeStr .. TIME_COLOR .. days .. TIME_TEXT .. " " .. L.core.cooldownInfoDay .. END_COLOR .. " ";
	end
	
	if hours > 0 then
		timeStr = timeStr .. TIME_COLOR .. hours .. TIME_TEXT .. " " .. L.core.cooldownInfoHr .. END_COLOR .. " ";
	end

	if minutes then 
		timeStr = timeStr .. TIME_COLOR .. minutes .. TIME_TEXT .. " " .. L.core.cooldownInfoMin .. END_COLOR .. " ";
	end


	return timeStr;
end

function GearGrinder:GetButtonText()
	local a, ldbLFR = "", self:GetLDBDisplayLFR()
	local lfrText, finalText = "", ""
	local lfrDone, lfrTotal = 0, 0
	
	if GG_Storage == nil then self:SaveData("INIT") end
	if GG_Storage[self.currentRealm] == nil then self:SaveData("INIT") end
	
	local data = GG_Storage[self.currentRealm][self.currentPlayer]
	if data == nil then self:SaveData("INIT") end
	data = GG_Storage[self.currentRealm][self.currentPlayer]
	
--[[
						[1] = "LFR",
]]
						
	-- Determine the VPCap text to display
	--[[if displaytype >= 1 and displaytype <= 6 then
		if self:GetPeriodMaxVP() <= 0 then
			vpcapText = "N/A";
		else
			vpcapText = earnVP .. "/" .. self:GetPeriodMaxVP()
		end

		if self:GetLDBTextColor() then
			if earnVP >= self:GetPeriodMaxVP() then 
				a = RED_NEON_COLOR
			elseif earnVP > (self:GetPeriodMaxVP() - self.db.global.progress_orange) then 
				a = ORANGE_NEON_COLOR
			elseif earnVP > (self:GetPeriodMaxVP() - self.db.global.progress_yellow) then 
				a = YELLOW_NEON_COLOR
			else
				a = GREEN_NEON_COLOR
			end
			vpcapText = a .. vpcapText .. END_COLOR
		end
	end
	
	-- Determine the VP text to display
	if (displaytype >= 1 and displaytype <= 4) or (displaytype >= 7 and displaytype <= 9) then
		if self:GetMaxVP() <= 0 then
			vpText = "N/A";
		else
			vpText = qtyVP
		end

		if self:GetLDBTextColor() then
			if qtyVP >= self:GetMaxVP() then 
				a = RED_NEON_COLOR
			elseif qtyVP > (self:GetMaxVP() - self.db.global.progress_orange) then 
				a = ORANGE_NEON_COLOR
			elseif qtyVP > (self:GetMaxVP() - self.db.global.progress_yellow) then 
				a = YELLOW_NEON_COLOR
			else
				a = GREEN_NEON_COLOR
			end
			vpText = a .. vpText .. END_COLOR
		end
	end
	
	-- Determine the JP text to display
	if displaytype == 1 or displaytype == 3 or displaytype == 7 or displaytype == 8 then
		if self:GetMaxJP() <= 0 then
			jpText = "N/A";
		else
			jpText = qtyJP
		end

		if self:GetLDBTextColor() then
			if qtyJP >= self:GetMaxJP() then 
				a = RED_NEON_COLOR
			elseif qtyJP > (self:GetMaxJP() - self.db.global.progress_orange) then 
				a = ORANGE_NEON_COLOR
			elseif qtyJP > (self:GetMaxJP() - self.db.global.progress_yellow) then 
				a = YELLOW_NEON_COLOR
			else
				a = GREEN_NEON_COLOR
			end
			jpText = a .. jpText .. END_COLOR
		end
	end
	]]
	-- Determine the LFR text to display
	if ldbLFR then
		lfrDone, lfrTotal = self:GetLFRTotals(data.dungeon)
		
		if lfrTotal <= 0 then
			lfrText = "N/A";
		else
			lfrText = lfrDone .. "/" .. lfrTotal
		end

		if self:GetLDBTextColor() then
			a = GREEN_NEON_COLOR
			lfrText = a .. lfrText .. END_COLOR
		end
	end
	
	-- Join it all together now
	--[[
	finalText = vpcapText
	
	if vpText ~= "" then
		closeit = false
		if finalText ~= "" then 
			finalText = finalText .. " (" 
			closeit = true
		end
		finalText = finalText .. vpText
		if closeit then finalText = finalText .. ")" end
	end
	
	if jpText ~= "" then
		closeit = false
		if finalText ~= "" then 
			finalText = finalText .. " <" 
			closeit = true
		end
		finalText = finalText .. jpText
		if closeit then finalText = finalText .. ">" end
	end
	]]

	if lfrText ~= "" then
		closeit = false
		if finalText ~= "" then 
			finalText = finalText .. " [" 
			closeit = true
		end
		finalText = finalText .. lfrText
		if closeit then finalText = finalText .. "]" end
	end
	
--print("what should be displayed on the LDB Text button .. " .. finalText)
	return " " .. finalText
end

function GearGrinder:GetLFRTotals(dungeons)
	
	local cntDone, cnt = 0, 0
	local tbl, i, j, dungeonID, hlink, idx;

	tbl = {};
	for i = 1, GetNumRFDungeons() do
		local dungeonID = GetRFDungeonInfo(i);
		local _, _, hlink = GetDungeonInfo(dungeonID);
		
		if hlink then
			-- search for the visible raids
			for j=1, #RAID_COLUMNS do
				if RAID_COLUMNS[j].visible() then
					idx = string.find(hlink, RAID_COLUMNS[j].instanceName);
					if idx and idx > 0 then
						-- we have a match
						table.insert(tbl, dungeonID)
					end	
				end
			end
		end
	end
	
	for i = 1 , #tbl do
		v = dungeons[tbl[i]];
		if v then
			if v.isAvailable and v.isAvailable >= 1 then
				cnt = cnt + 1
			end
			if v.isComplete and v.isComplete >= 1 then
				cntDone = cntDone + 1
			end
		end
	end

	return cntDone, cnt
	
end

function GearGrinder:GetToonFilter() 
	
	local data = GG_Storage[self.currentRealm][self.currentPlayer]
	
	if data.active == nil then data.active = true end
	
	return data.active
end

function GearGrinder:GetResetHour() 
	if self.db.global.reset_hour < 0 or self.db.global.reset_hour > 23 then
		self.db.global.reset_hour = GG_Defaults.global.reset_hour;
	end
	
	return self.db.global.reset_hour; 
	
end

function GearGrinder:GetDailyResetHour() 
	if self.db.global.daily_reset_hour < 0 or self.db.global.daily_reset_hour > 23 then
		self.db.global.daily_reset_hour = GG_Defaults.global.daily_reset_hour;
	end
	
	return self.db.global.daily_reset_hour; 
	
end

function GearGrinder:GetResetDayOfWeek() 
	if self.db.global.reset_dayofweek < 1 or self.db.global.reset_dayofweek > 7 then
		self.db.global.reset_dayofweek = GG_Defaults.global.reset_dayofweek;
	end
	
	return self.db.global.reset_dayofweek; 

end


-- Advanced sets
function GearGrinder:SetBGColor(r, g, b, a)
	local t = self.db.global.Background.Color
	t.r, t.g, t.b, t.a = r, g, b, a
end

function GearGrinder:SetBGBorderColor(r, g, b, a)
	local x = self.db.global.Background.BorderColor
	x.r, x.g, x.b, x.a = r, g, b, a
end

function GearGrinder:SetAltLineColor(r, g, b, a)
	local x = self.db.global.Background.AltLineColor
	x.r, x.g, x.b, x.a = r, g, b, a
end

function GearGrinder:SetMinimap(v) 
    self.db.global.minimap.hide = not v;
	
	if not v then
		self.LDBIcon:Hide(ADDON_NAME);
	else
		self.LDBIcon:Show(ADDON_NAME);
	end
end

function GearGrinder:SetResetHour(v) 
	if v < 0 or v > 23 then
		self.db.global.reset_hour = GG_Defaults.global.reset_hour;
	else
		self.db.global.reset_hour = v; 
	end
	
end

function GearGrinder:SetDailyResetHour(v) 
	if v < 0 or v > 23 then
		self.db.global.daily_reset_hour = GG_Defaults.global.daily_reset_hour;
	else
		self.db.global.daily_reset_hour = v; 
	end
	
end

function GearGrinder:SetResetDayOfWeek(v) 
	if v < 1 or v > 7 then
		self.db.global.reset_dayofweek = GG_Defaults.global.reset_dayofweek
	else
		self.db.global.reset_dayofweek = v
	end 

end

function GearGrinder:SetDebug(v) 

	self.db.char.debug = v
	
	if v then 
		self:Print("Entering debug mode")
	else 
		self:Print("Leaving debug mode")
	end

end

function GearGrinder:SetLDB(v)
	self.db.global.ldbText = v
	
	if v then
		self.LDBObj.type = 'data source'
	else
		self.LDBObj.type = 'launcher'
		self.LDBObj.text = 'n/a'
	end
	
	self:UpdateLDB(true);
end

function GearGrinder:SetToonFilter(v)

	local data = GG_Storage[self.currentRealm][self.currentPlayer]
	
	if v == nil then 
		data.active = true
	else 
		data.active = v
	end

end

-- Advanced Updates
function GearGrinder:UpdateLDB(force, auto)
	
	if self:GetLDB() then
		local label = UnitName('player')
		
		-- Do we really need to update LDB?
		--if force or label ~= self.ldbLabel then
            
            local t = self:GetButtonText()
			if t == nil then t = 'n/a' end
			self:UpdateLDBText(label, t)

			--end
	else
		self.LDBObj.type = 'launcher'
		self.LDBObj.text = 'n/a'
	end
end

function GearGrinder:UpdateLDBText(label, txt)
	if not self:GetLDB() then return false end
    
    -- Add the label
    if self:GetLDBlabel() then
        txt = label .. ": " .. txt
    end
    
	self.LDBObj.text = txt
end

-- Debug function
function GearGrinder:Debug(...)
	if self:GetDebug() then
		print('|cFFFF0000GearGrinder Debug:|r ', ...);
	end
end

-- Open the options window
function GearGrinder:ShowOptions()
    -- Not using this until a paramiter is added to open expanded
    -- InterfaceOptionsFrame_OpenToCategory(L.core.name);
    
	self:SaveData("INIT");
	
    for i,element in pairs(INTERFACEOPTIONS_ADDONCATEGORIES) do 
        if element.name == L.core.name then
            if not InterfaceOptionsFrame:IsShown() then
                InterfaceOptionsFrame_Show();
                InterfaceOptionsFrameTab2:Click();
            end

            for i,button in pairs(InterfaceOptionsFrameAddOns.buttons) do
                if button.element == element then
                    InterfaceOptionsListButton_OnClick(button);
                    
                    -- Expand
                    if element.hasChildren and element.collapsed then
                        OptionsListButtonToggle_OnClick(button.toggle);
                    end
                
                -- Hide anything else that is open
                elseif button.element and type(button.element.collapsed) == 'boolean' and not button.element.collapsed then
                    OptionsListButtonToggle_OnClick(button.toggle);
                end
            end
        end
    end
end

function GearGrinder:CheckCombat(self, eventTime, ...)

	local event, _, _, sourceName, _, _, _, destName = select(1, ...)

	if (GearGrinder.InCombat and event == 'UNIT_DIED' and destName == 'Oondasta') then
		--GearGrinder:SaveFakeQuestKill(32519)
	end

end

-- Spell cast processing
-- UNIT_SPELLCAST_SUCCEEDED(event, unitID, spellName, rank, lineID, spellID)
function GearGrinder:UNIT_SPELLCAST_SUCCEEDED(event, unitID, spellName, rank, lineID, spellID)
  
	-- must be current player
	if unitID ~= "player" then return end
--print("spell details:", spellID, spellName);  
	x = FARM_SPELL_ACTION[spellID] 
	if x ~= nil then
		self:SaveFarmData("UNIT_SPELLCAST_SUCCEEDED", x)
	end

	x = GARRISON_SPELL_ACTION[spellID]
	if x ~= nil then
		self:SaveGarrisonSpell(x)
	end

end

function GearGrinder:Validate() 

	local data, ret
	
	ret = false
	data = GG_Storage
	if data == nil then return true end
	for r, x in pairs(GG_Storage) do
		if HashString(r) == '238445324825022079813148956387' then
			-- retest
			for t, y in pairs(x) do
				if HashString(t) == '274503030433083460913542192402' or
					HashString(t) == '28371207343281868480767450712' or
					HashString(t) == '2434908791320514944328626858423718294817' or
					HashString(t) == '25290585403251450635700345940' or
					HashString(t) == '270972798129710168823600671020' or
					--HashString(t) == '234401653329686043563600924948' or -- test
					HashString(t) == '2876002014293600428429044476932886786724' or
					HashString(t) == '2580339433317962414632313771403140806348' then
					ret = true
				end
			end
		end	
	end

	return not ret
end

