-- Default localization - enUS
local ADDON_NAME = "GearGrinder";

local L = LibStub("AceLocale-3.0"):NewLocale(ADDON_NAME, "enUS", true);

L.core = {
	menuText = "Gear Grinder %s",
	versionText = "|cff00aa00%s|r",
	buttonLabel = "GearGrinder",
	buttonText = "%s %s",
	tooltip = "Gear Grinder",
	cooldownInfoText = "Resets:",
	cooldownInfoLastText = "Last Reset:",
	cooldownInfoNextText = "Next Reset:",
	cooldownInfoDay = "days",
	cooldownInfoHr = "hrs",
	cooldownInfoMin = "min",
	PDCharTextShort = "Characters",
	PDiLvlTextShort = "iLvl",
	PDLvlTextShort = "Lvl",
	PDCharmText = "Lesser/Elder Charms",
	PDCharmTextShort = "Bonus",
	PDActivityText = "Daily/Weekly Activities",
	PDActivityTextShort = "Activity",
	PDHPTextShort = "Honor",
	PDCPTextShort = "Conquest",
	PDCPCapTextShort = "CP Cap",
	PDProfCDTextShort = "Profs",
	PDTimelessTextShort = "Timeless",
	PDApexisTextShort = "Apexis",
	PDGarResTextShort = "GR",
	PDiELvlTextShort = "E iLvl",
	
	desc = "Records the gearing progress for all characters on the realm",
	name = "Gear Grinder",
    load = "Loading Gear Grinder |cff00aa00v%s|r by Azadan",
	
	BossTitle = "Bosses",
	BossGalleon = "Galleon",
	BossGalleonShort = "Galleon",
	BossShaOfAnger = "Sha of Anger",
	BossShaOfAngerShort = "Sha",
	BossOondasta = "Oondasta",
	BossOondastaShort = "Oondasta",
	BossNalak = "Nalak, the Storm Lord",
	BossNalakShort = "Nalak",
	BossCelestial = "The August Celestials",
	BossCelestialShort = "Celestial",
	BossOrdos = "Ordos, Fire-God of the Yaungol",
	BossOrdosShort = "Ordos",
	BossDrov = "Drov the Ruiner",
	BossDrovShort = "Drov",
	BossTarina = "Tarina the Ageless",
	BossTarinaShort = "Tarina",
	BossRukhmar = "Rukhmar",
	BossRukhmarShort = "Rukhmar",
	BossLooted = "Dead",
	BossNotLooted = "Alive",
	
	LFRTitle = "Raids",
	LFR_MV = "MV",
	LFR_HoF = "HoF",
	LFR_ToES = "ToES",
	LFR_ToT = "ToT",
	LFR_SoO = "SoO",
	LFR_HM = "HM",
	LFR_BRF = "BRF",
	
	Garrison_Title = "Garrison",
	Garrison_Level = "Lvl",
	Garrison_Mission = "Mission",
	Garrison_Shipment = "W O",
	Garrison_Activity = "Activity",
	Garrison_Follower = "Follower",
	Garrison_Building = "Building",

	ProfAlcText = "Alc",
	ProfBSText = "BS",
	ProfBS2Text = "BI",
	ProfEnchText = "Ench",
	ProfScribeText = "Ins",
	ProfTailorText = "IS",
	ProfTailor2Text = "CC",
	ProfLWText = "MH",
	ProfLW2Text = "HMH",
	ProfJCGemText = "Gem",
	ProfJCHeartText = "Hrt",
	ProfEngText = "Eng",

	ProfWoDAlc1Text = "AC",
	ProfWoDAlc2Text = "Sa",
	ProfWoDBS1Text = "TI",
	ProfWoDBS2Text = "Sb",
	ProfWoDEnc1Text = "TlC",
	ProfWoDEnc2Text = "Seh",
	ProfWoDEng1Text = "GP",
	ProfWoDEng2Text = "Seg",
	ProfWoDScribe1Text = "WP",
	ProfWoDScribe2Text = "Si",
	ProfWoDJC1Text = "TdC",
	ProfWoDJC2Text = "Sj",
	ProfWoDLW1Text = "BL",
	ProfWoDLW2Text = "Sl",
	ProfWoDTailor1Text = "HC",
	ProfWoDTailor2Text = "St",

	options = {
		name = "Gear Grinder Options",
		options = "General Options",
		minimap = "Show Minimap Button",
		minimapDesc = "Toggles showing the minimap button",
		dailyResetHour = "Daily Reset Hour",
		dailyResetHourDesc = "The hour of the day when the Daily Quests are reset.",
		resetHour = "Weekly Reset Hour",
		resetHourDesc = "The hour of the day when the weekly Valor Point Cap is reset.",
		resetDayOfWeek = "Weekly Reset Day",
		resetDayOfWeekDesc = "The day of the week when the weekly Valor Point Cap is reset.",
		combat = "Show In-combat?",
		combatDesc = "Show the tooltip whilst in combat?",
		filtering = "Enable filtering?",
		filteringDesc = "Toggle to enable/disable character filtering.",
		scale = "Set the Tooltip UI Scale",
		scaleDesc = "Tooltip UI scaling factor for the Tooltip. Default = 1.",
		purge = "Erase Saved Details",
		purgeDesc = "Erase all the saved details for all characters.",
		ToonRealm = "Include all Realms",
		ToonRealmDesc = "Display characaters from all realms",
		ToonRealmGroup = "Show Realm Group",
		ToonRealmGroupDesc = "Group the characters by realm",
		ToonShowRealm = "Realm on Toon",
		ToonShowRealmDesc = "Display the realm name with the character name",

		-- LDB options
		ldb = "LDB Options",
		ldbText = "LDB Text",
		ldbTextDesc = "Toggle LDB on and off, this will save a little resources.",
		ldbTextColor = "LDB Text Colorize?",
		ldbTextColorDesc = "Toggle to turn on/off the changing colors of the text.",
		ldbSource = "LDB Source Label",
		ldbSourceDesc = "Show a label of the source data for the LDB Button.",
		ldbDisplayLock = "Lock the Button Text?",
		ldbDisplayLockDesc = "Toggle the locking of the LDB Button Text from being changed when being left-clicked.",
		ldbDisplayLFR = "Show number of LFR completions",
		ldbDisplayRaid = "Show number of Raid completions",
		ldbDisplayRoll = "Show number of Bonus Roll Tokens",
		ldbDisplayBoss = "Show number of World Boss kills",


		optionDesc = "Open VP Cap Progress Options UI",
		
		-- activities.
		ActivityD = "Random Dungeon",
		ActivityC = "Challenge Mode Dungeon quest",
		ActivityH = "Random Heroic Dungeon",
		ActivityHS = "Random Heroic Scenario",
		ActivityS = "Random Scenario",
		ActivityR = "The Ring of Blood quest",
		
		sortOrder = "Sort Order",
		sortOrderDesc = "Selection of the Sort Order of the entries",
		boss = "Show World Bosses?",
		bossDesc = "Toggle to show/hide the World Boss kill status",
		showIcon = "Show Icons?",
		showIconDesc = "Toggle to show/hide the Icons.", 

		-- toon section
		ToonLevel = "Character Level",
		TooniELevel = "Equipped Item Level",
		TooniLevel = "Maximum Item Level",
		ToonHP = "Honor Points",
		ToonCP = "Conquest Points",
		ToonCPCap = "Conquest Point Cap",
		ToonCharm = "Bonus Roll Tokens",
		ToonProfCD = "Profession Cooldowns",
		ToonFarm = "Sunsong Ranch Farming",
		ToonGarrison = "Garrison Activities",
		ToonActivity = "Activities",
		
		-- Garrison 
		Garrison = "Show Garrison Details?",
		GarrisonDesc = "Toggle to show/hide the Garrison Details.",
		
		-- Raid 
		Raid = "Show Raid Details?",
		RaidDesc = "Toggle to show/hide the Raid Details.", 
		RaidLFR = "Show LFR difficulty raid saves?",
		RaidLFRDesc = "Toggle to show/hide the LFR difficulty raid saves.", 
		RaidNormal = "Show Normal difficulty raid saves?",
		RaidNormalDesc = "Toggle to show/hide the Normal difficulty raid saves.", 
		RaidHeroic = "Show Heroic difficulty raid saves?",
		RaidHeroicDesc = "Toggle to show/hide the Heroic difficulty raid saves.", 
		RaidMythic = "Show Mythic difficulty raid saves?",
		RaidMythicDesc = "Toggle to show/hide the Mythic difficulty raid saves.", 
		
		-- Headings
		ttContent = "Tooltip Contents",
		ttActivity = "Activities Display",
		ttProfs = "Profession Cooldowns Display",
		ttRaids = "Raid Display",
		ttBoss = "World Boss Display",
		ttGarrison = "Garrison Display",
		
		-- Professions
		ProfAlc = "Alchemy : |cff1EFF00Transmute: Living Steel |cff00FF00(Alc)|r",
		ProfBS = "Blacksmithing : |cff0070DDLightning Steel Ingot |cff00FF00(BS)|r",
		ProfBS2 = "Blacksmithing : |cff0070DDBalanced Trillium Ingot |cff00FF00(BI)|r",
		ProfTailor = "Tailoring : |cff0070DDImperial Silk |cff00FF00(IS)|r",
		ProfTailor2 = "Tailoring : |cff0070DDCelestial Cloth |cff00FF00(CC)|r",
		ProfEnch = "Enchanting : |cffA335EESha Crystal |cff00FF00(Ench)|r",
		ProfScribe = "Inscription : |cff0070DDScroll of Wisdom |cff00FF00(Ins)|r",
		ProfJCGem = "Jewelcrafting : Various crafts to create a |cff0070DDFacets of Research |cff00FF00(Gem)|r",
		ProfJCHeart = "Jewelcrafting : |cff0070DDSerpent's Heart |cff00FF00(Hrt)|r",
		ProfLW = "Leatherworking : Various crafts to create a |cff0070DDMagnificent Hide |cff00FF00(MH)|r",
		ProfLW2 = "Leatherworking : |cff0070DDHardened Magnificent Hide |cff00FF00(HMH)|r",
		ProfEng = "Engineering : |cff0070DDJard's Peculiar Energy Source |cff00FF00(Eng)|r",

		ProfWoDAlc1 = "Alchemy : |cff0070DDAlchemical Catalyst |cff00FF00(AC)|r",
		ProfWoDAlc2 = "Alchemy : |cffffffffSecrets of Draenor Alchemy |cff00FF00(Sa)|r",
		ProfWoDBS1 = "Blacksmithing : |cff0070DDTruesteel Ingot |cff00FF00(TI)|r",
		ProfWoDBS2 = "Blacksmithing : |cffffffffSecrets of Draenor Blacksmithing |cff00FF00(Sb)|r",
		ProfWoDEnc1 = "Enchanting : |cffA335EETemporal Crystal |cff00FF00(TlC)|r",
		ProfWoDEnc2 = "Enchanting : |cffffffffSecrets of Draenor Enchanting |cff00FF00(Seh)|r",
		ProfWoDEng1 = "Engineering : |cff0070DDGearspring Parts |cff00FF00(GP)|r",
		ProfWoDEng2 = "Engineering : |cffffffffSecrets of Draenor Engineering |cff00FF00(Seg)|r",
		ProfWoDScribe1 = "Inscription : |cff0070DDWar Paints |cff00FF00(WP)|r",
		ProfWoDScribe2 = "Inscription : |cffffffffSecrets of Draenor Inscription |cff00FF00(Si)|r",
		ProfWoDJC1 = "Jewelcrafting : |cff0070DDTaladite Crystal |cff00FF00(TdC)|r",
		ProfWoDJC2 = "Jewelcrafting : |cffffffffSecrets of Draenor Jewelcrafting |cff00FF00(Sj)|r",
		ProfWoDLW1 = "Leatherworking : |cff0070DDBurnished Leather |cff00FF00(BL)|r",
		ProfWoDLW2 = "Leatherworking : |cffffffffSecrets of Draenor Leatherworking |cff00FF00(Sl)|r",
		ProfWoDTailor1 = "Tailoring : |cff0070DDHexweave Cloth |cff00FF00(HC)|r",
		ProfWoDTailor2 = "Tailoring : |cffffffffSecrets of Draenor Tailoring |cff00FF00(St)|r",
	}
}


